#include "pm.h"

void make_filename(int x)
{
   char temp[20];
   extern char level_filename[20];
   char msg[80];
   
   strcpy( temp, "LEVEL");

   if (x < 10) sprintf(msg,"00%-1d", x);
   if (x  > 9) sprintf(msg,"0%-2d", x);

   strcat( temp, msg);
   strcat( temp, ".PML");
   strcpy(level_filename, temp);
}
int load_sprit(void)
{
FILE *filepntr;
char sprit_filename[20] = "SPRIT001.PM";
extern BITMAP *memory_bitmap[512];
extern PALLETE pallete;
extern int zz[20][64];

int sprit_load_error = 0;
int c, x, y;
int dsp = 0;
char msg[80];

   if (dsp) textout(screen, font, "Loading shapes...", SCREEN_W/2, (SCREEN_H*3)/4, 1);
   sprit_load_error = 0;
   if (exists(sprit_filename) == 0) /* does file exist? */
      {
         sprintf(msg, "Can't find sprit %s ", sprit_filename);
         textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
         sprit_load_error = 1;
      }
   if (!sprit_load_error)  /* open file */
      if ((filepntr=fopen(sprit_filename,"rb")) == NULL)
         {
            sprintf(msg, "Error opening %s ", sprit_filename);
            textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
            sprit_load_error = 1;
         }
   if (!sprit_load_error)  /* file open ! */
      {
         for (c=0; c<512; c++)   /* 512 bitmaps */
            {
               if (dsp)
                  {
                     sprintf(msg,".%d ", 512-c);
                     textout(screen, font, msg, 152, 184, 1);
                  }
               for (y=0; y<20; y++)
                  for (x=0; x<20; x++)
                     putpixel(memory_bitmap[c],x,y, fgetc(filepntr));
             }
         for (c=0; c<256; c++)      /* 256 colors */
               {
                  pallete[c].r = fgetc(filepntr);
                  pallete[c].g = fgetc(filepntr);
                  pallete[c].b = fgetc(filepntr);
               }
         for (c=0; c<64; c++)
            for (y=0; y<20; y++)
               {
                  x = fgetc(filepntr);
                  if (x) zz[y][c] = 256 + fgetc(filepntr);
                  else   zz[y][c] = fgetc(filepntr);
               }
      } /* end of if not sprit load error */
   fclose(filepntr);
   set_pallete(pallete);
   if (sprit_load_error)
      {
         rest(2000);
         return 0;
      }
   else return 1;
}
int load_level(int level_to_load, int display)
{
FILE *filepntr;
extern char level_filename[20];
extern char level_text[100][40];
extern int level_header[20];
extern int l[100][100];
extern int item[500][16];
extern int Ei[100][10];
extern float Ef[100][10];
extern int mov_ob[20][20];
extern int mov_obi[20][20][4];
int level_load_error = 0;
int loop, ch, c, x, y;
char buff[20];
char msg[80];

   /* erase all old data */
   for (x=0; x<20; x++)
      level_header[x] = 0;
   
   for (c=0; c<100; c++)  /* level */
      for (x=0; x<100; x++)
           l[c][x] = 0;
   
   for (c=0; c < 500; c++) /* item */
      for (x=0; x<16; x++)
         item[c][x] = 0;
   
   for (c=0; c < 100; c++)  /* enemy float */
       for (x=0; x<10; x++)
            Ef[c][x] = 0;
   for (c=0; c < 100; c++) /* enemy int */
       for (x=0; x<10; x++)
            Ei[c][x] = 0;
   
   for (c = 0; c < 20; c++)
      for (x = 0; x < 20; x++)
         mov_ob[c][x] = 0;
   
   for (c = 0; c < 20; c++)
      for (x = 0; x < 20; x++)
         for (y = 0; y < 4; y++)
            mov_obi[c][x][y] = 0;

   make_filename(level_to_load);   /* update filename */
   if (display)
      {
         sprintf(msg, "...loading level %d...", level_to_load);
         textout_centre(screen, font, msg, SCREEN_W/2, (SCREEN_H)/2+8, 10);
      }
   level_load_error = 0;
   if ((exists(level_filename)) == 0)
      {
         sprintf(msg, "Can't Find Level %s ", level_filename);
         textout_centre(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 10);
         level_load_error = 1;
      }
   if (!level_load_error) /* file exists */
      {
         /* erase all old data */
         for (x=0; x<20; x++)
            level_header[x] = 0;
         
         for (c=0; c<100; c++)  /* level */
            for (x=0; x<100; x++)
                 l[c][x] = 0;
         
         for (c=0; c < 500; c++) /* item */
            for (x=0; x<16; x++)
               item[c][x] = 0;
         
         for (c=0; c < 100; c++)  /* enemy float */
             for (x=0; x<10; x++)
                  Ef[c][x] = 0;
         for (c=0; c < 100; c++) /* enemy int */
             for (x=0; x<10; x++)
                  Ei[c][x] = 0;
         
         for (c = 0; c < 20; c++)
            for (x = 0; x < 20; x++)
               mov_ob[c][x] = 0;
         
         for (c = 0; c < 20; c++)
            for (x = 0; x < 20; x++)
               for (y = 0; y < 4; y++)
                  mov_obi[c][x][y] = 0;
      }
   if (!level_load_error) /* file exists */
      {
         if ((filepntr=fopen(level_filename,"r")) == NULL)
            {
               sprintf(msg, "Error opening %s ", level_filename);
               textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
               level_load_error = 1;
            }
         if (!level_load_error)  /* file open ! */
            {
               for (c=0; c<20; c++) /* level header */
                  {
                     loop = 0;
                     ch = fgetc(filepntr);
                     while((ch != '\n') && (ch != EOF))
                        {
                           buff[loop] = ch;
                           loop++;
                           ch = fgetc(filepntr);
                        }
                     buff[loop] = NULL;
                     level_header[c] = atoi(buff);
                     if (ch == EOF)
                        {
                           sprintf(msg, "Error reading %s ", level_filename);
                           textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                           rest(3000);
                           level_load_error = 1;
                        }
                  }
               for (c=0; c<100; c++)  /* l[100][100] */
                  for (y=0; y<100; y++)
                     {
                        loop = 0;
                        ch = fgetc(filepntr);
                        while((ch != '\n') && (ch != EOF))
                           {
                               buff[loop] = ch;
                               loop++;
                               ch = fgetc(filepntr);
                           }
                        buff[loop] = NULL;
                        l[c][y] = atoi(buff);
                        if (ch == EOF)
                           {
                              sprintf(msg, "Error reading %s ", level_filename);
                              textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                              rest(3000);
                              level_load_error = 1;
                           }
                     }
               if (!level_load_error)
                  {
                     for (c = 0; c < level_header[3]; c++)  /* read item */
                        for (x = 0; x < 16; x++)
                           {
                              loop = 0;
                              ch = fgetc(filepntr);
                              while((ch != '\n') && (ch != EOF))
                                 {
                                     buff[loop] = ch;
                                     loop++;
                                     ch = fgetc(filepntr);
                                 }
                              buff[loop] = NULL;
                              item[c][x] = atoi(buff);
                              if (ch == EOF)
                                 {
                                    sprintf(msg, "Error reading items in %s ", level_filename);
                                    textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                    rest(3000);
                                    level_load_error = 1;
                                 }
                           }
                  }
               if (!level_load_error)
                  {
                     for (c=0; c<level_header[4]; c++) /* read enemy floats */
                        for (x=0; x<10; x++)
                           {
                              loop = 0;
                              ch = fgetc(filepntr);
                              while((ch != '\n') && (ch != EOF))
                                 {
                                    buff[loop] = ch;
                                    loop++;
                                    ch = fgetc(filepntr);
                                 }
                              buff[loop] = NULL;
                              Ef[c][x] = atof(buff);
                              if (ch == EOF)
                                 {
                                    sprintf(msg, "Error reading Ef in %s ", level_filename);
                                    textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                    rest(3000);
                                    level_load_error = 1;
                                 }
                           }

                     for (c=0; c < level_header[4]; c++)  /* enemy ints */
                        for (x=0; x<10; x++)
                           {
                              loop = 0;
                              ch = fgetc(filepntr);
                              while((ch != '\n') && (ch != EOF))
                                 {
                                     buff[loop] = ch;
                                     loop++;
                                     ch = fgetc(filepntr);
                                 }
                              buff[loop] = NULL;
                              Ei[c][x] = atoi(buff);
                              if (ch == EOF)
                                 {
                                    sprintf(msg, "Error reading Ei in %s ", level_filename);
                                    textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                    rest(3000);
                                    level_load_error = 1;
                                 }

                           }
                  }
               if (!level_load_error)
                  {
                     for (c=0; c<level_header[5]; c++) /* read mov_ob */
                        for (x=0; x<20; x++)
                            {
                               loop = 0;
                               ch = fgetc(filepntr);
                               while((ch != '\n') && (ch != EOF))
                                  {
                                      buff[loop] = ch;
                                      loop++;
                                      ch = fgetc(filepntr);
                                  }
                               buff[loop] = NULL;
                               mov_ob[c][x] = atoi(buff);
                               if (ch == EOF)
                                  {
                                     sprintf(msg, "Error reading mov_ob[%d][%d] in %s ", level_filename, c, x);
                                     textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                     rest(3000);
                                     level_load_error = 1;
                                  }
                             }
                  }
               if (!level_load_error)
                  {
                     for (c=0; c<level_header[5]; c++) /* read mov_obi[20][10][4] */
                        for (x=0; x<20; x++)
                         for (y=0; y<4; y++)
                           {
                              loop = 0;
                              ch = fgetc(filepntr);
                              while((ch != '\n') && (ch != EOF))
                                 {
                                     buff[loop] = ch;
                                     loop++;
                                     ch = fgetc(filepntr);
                                 }
                              buff[loop] = NULL;
                              mov_obi[c][x][y] = atoi(buff);
                              if (ch == EOF)
                                 {
                                    sprintf(msg, "Error reading mov_obi[%d][%d][%d] in %s ", level_filename, c, x);
                                    textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                    rest(3000);
                                    level_load_error = 1;
                                 }
                            }
                  }
               if (!level_load_error)
                  {
                     for (c=0; c < level_header[6]; c++)  /* level text */
                        {
                           loop = 0;
                           ch = fgetc(filepntr);
                           while((ch != '\n') && (ch != EOF))
                              {
                                 level_text[c][loop] = ch;
                                 loop++;
                                 ch = fgetc(filepntr);
                              }
                           level_text[c][loop] = NULL;
                           if (ch == EOF)
                              {
                                 sprintf(msg,"Error reading lvltxt at %d %d %d", loop, c, x);
                                 textout(screen, font, msg, SCREEN_W/2, ((SCREEN_H*3)/4)+10, 1);
                                 rest(3000);
                              }
                        }
                  }
               fclose(filepntr);
            } /* end of file open */
      } /* end of if exists */

   if (level_load_error)
      {
         rest(2000);
         return 0;
      }
   else return 1;

}

#ifdef FV

int save_level(level_to_save)
{
FILE *filepntr;
extern char level_filename[20];
char buff[20];
extern char level_text[100][40];
extern int level_header[20];
extern int l[100][100];
extern int item[500][16];
extern int Ei[100][10];
extern float Ef[100][10];

extern int mov_ob[20][20];
extern int mov_obi[20][20][4];

int c, x, y;

make_filename(level_to_save);   /* update filename */

                      filepntr = fopen(level_filename,"w");

                           for (x=0; x<20; x++)
                              fprintf(filepntr,"%d\n",level_header[x]);

                           for (c=0; c<100; c++)  /* level */
                              for (x=0; x<100; x++)
                                   fprintf(filepntr,"%d\n",l[c][x]);

                           for (c=0; c < level_header[3]; c++) /* item */
                              for (x=0; x<16; x++)
                                   fprintf(filepntr,"%d\n",item[c][x]);

                           for (c=0; c < level_header[4]; c++)  /* enemy float */
                               for (x=0; x<10; x++)
                                    fprintf(filepntr,"%f\n",Ef[c][x]);
                           for (c=0; c < level_header[4]; c++) /* enemy int */
                               for (x=0; x<10; x++)
                                    fprintf(filepntr,"%d\n",Ei[c][x]);


                           /* moveable objects */

                           for (c=0; c < level_header[5]; c++) /* mov_ob */
                              for (x=0; x<20; x++)
                                    fprintf(filepntr,"%d\n",mov_ob[c][x]);

                           for (c=0; c < level_header[5]; c++) /* mov_obi */
                              for (x=0; x<20; x++)
                                  for (y=0; y<4; y++)
                                     fprintf(filepntr,"%d\n",mov_obi[c][x][y]);


                           for (c=0; c < level_header[6]; c++) /* enemy text */
                              fprintf(filepntr,"%s\n",level_text[c]);

                           fclose(filepntr);
}

#endif
