#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <allegro.h>
#include "pm.h"

/* global variables  */

extern BITMAP *memory_bitmap[512];
extern BITMAP *level_2000, *scrn_buffer;
extern BITMAP *map100_bmp, *map100_bkg;
extern BITMAP *pm_title;
extern PALLETE pallete;
extern SAMPLE *snd[20];
extern int fuse_loop_playing;
extern int lit_item;


extern char level_text[100][40];
extern int level_header[20];
extern int l[100][100];    /* level */
extern int item[500][16];  /* items */
extern int Ei[100][10];    /* enemies */
extern float Ef[100][10];  /* enemies */
extern int zz[20][64];

/* timer variables  */
extern volatile int msec_timer;
extern int level_time;
extern int passcount;

/* new x move stuff */
extern float right_speed, left_speed;
extern float initial_x_speed, max_x_speed;
extern float p_xmove;
extern float accel, de_accel;
extern float jump_sinc, fall_sinc;
extern float pmovey;

extern int joy_key;
extern int joy_buttons;
extern int joy_jump;
extern int joy_fire;
extern int joy_map;
extern int joy_menu;
extern int job[5];

extern int right_key;
extern int left_key;
extern int up_key;
extern int down_key;
extern int jump_key;
extern int fire_key;
extern int map_key;
extern int menu_key;

extern int jump;
extern int fire;

extern int play_level;
extern int start_level;
extern int start_mode;
extern int resume_allowed;

extern int top_menu_sel;

extern int speed;
extern int dif;

extern float LIFE;
extern int LIVES;

extern int sound_on;
extern int frame_speed;
extern int fade_count;

extern int WX, WY;
extern float PX, PY;
extern int PXint, PYint;
extern int num_bullets;
extern int max_bullets;

extern int pbullet[50][6];
extern int bullet_wait_counter, request_bullet;
extern int bullet_wait, bullet_speed;
extern int pm_bullet_collision_box;

extern int e_bullet_active[50], e_bullet_shape[50];
extern int enemy_bullet_colision_window;
extern float e_bullet_x[50], e_bullet_y[50], e_bullet_xinc[50], e_bullet_yinc[50];

extern int bomb[20][5];

extern float itemf[500][4];

extern int player_ride;
extern float mov_obf[20][4];
extern int mov_ob[20][20];
extern int mov_obi[20][20][4];

extern int player_carry;
extern int fire_held;
extern int map_held;

extern int left_right;
extern float jump_count, fall_count;

extern int map_on;

extern int level_done;
extern int game_exit;
extern int num_enemy;

/* counters and temp string  */
int a, b, c, d, e, f, x, y;
extern char msg[80];
extern char b_msg[80];
extern int bottom_msg;
extern int pop_msg;

extern int map100_x, map100_y;
extern int map100_on, top_display_on;
extern int top_display_x, top_display_y, top_display_color;
extern int bottom_display_y, bottom_display_color;

extern int map_solid_color, map_semi_color;
extern int map_break_color, map_empty_color;
extern int map_enemy_color , map_bullet_color;
extern int map_item_color, map_player_color;


void get_new_background()
{
    WX = PX - (SCREEN_W/2)-10; /* set window from PX,PY */
    WY = PY - (SCREEN_H/2)-10;
    if (WX < 0) WX = 0;
    if (WX > 1999 - SCREEN_W) WX = 1999 - SCREEN_W;
    if (WY > 1999 - SCREEN_H) WY = 1999 - SCREEN_H;
    if (WY < 0) WY = 0;
    blit(level_2000, scrn_buffer, WX, WY, 0, 0, SCREEN_W, SCREEN_H);
}

void draw_pop_msg()
{
   int ln1 = item[pop_msg-1][6]-1;
   int ln2 = item[pop_msg-1][7]-1;
   int text_color = item[pop_msg-1][8];
   int frame_color = item[pop_msg-1][9];
   int px, py, px2, py2;
   int width = 1; /* default */
   int border = 8;
   int height;

   height = 1 + abs(ln2-ln1); /* if zero height is one line */

   for (y=ln1; y<= ln2; y++) /* find width */
      if (strlen(level_text[y]) > width)
         width = strlen(level_text[y]);
   px = (SCREEN_W - border - (width*8)) / 2;
   py = 20;
   px2 = px+(width*8)+(border*2);
   py2 = py+(height*8)+(border*2);

   rectfill(scrn_buffer, px,py,px2,py2,0); /* clear */
   for (y=0; y<border; y++)
       {
          int color_offset = y*16;
          rect(scrn_buffer, px+y,py+y,px2-y,py2-y,frame_color+color_offset); /* frame */
       }
   for (y=ln1; y<=ln2; y++)
       textout_centre(scrn_buffer, font, level_text[y]
        ,1+border+px+(width*4),1+border+py + ((y-ln1)*8), text_color); /* text line */
}
void proc_controllers()
{
    jump=0;
    fire=0;

    if ((key[KEY_ESC]) || (key[menu_key]))
         {
            resume_allowed = 1;
            game_exit = 1;
         }

    switch (joy_key)
       {
          case 0: /* keyboard */
             if (key[fire_key]) fire = 1;
             else fire_held = 0;
             if (key[jump_key]) jump = 1;

      
          if ((key[map_key]) && (!map_held))
             {
                map100_on = !map100_on;
                map_held = 1;
             }
          if ((!key[map_key]) && (map_held))
             map_held = 0;


          break;
          case 1: /* standard joystick control */
             poll_joystick();
             job[1] = joy_b1;
             job[2] = joy_b2;
             if (job[joy_fire]) fire = 1;
             else fire_held = 0;
             if (job[joy_jump]) jump = 1;

             if ((key[map_key]) && (!map_held)) /* key map */
                {
                   map100_on = !map100_on;
                   map_held = 1;
                }
             if ((!key[map_key]) && (map_held))
                map_held = 0;
          break;
          case 4: /* 4 button joystick */
             poll_joystick();
             job[1] = joy_b1;
             job[2] = joy_b2;
             job[3] = joy_b3;
             job[4] = joy_b4;
             if (job[joy_fire]) fire = 1;
             else fire_held = 0;
             if (job[joy_jump]) jump = 1;
             if ((job[joy_map]) && (!map_held))
                {
                   map100_on = !map100_on;
                   map_held = 1;
                }
             if ((!job[joy_map]) && (map_held))
                map_held = 0;
             if (job[joy_menu])
                {
                   resume_allowed = 1;
                   game_exit = 1;
                }
          break;
     }
}

void enemy_move()
{
int EN, b, c, x, y;

   for (EN=0; EN<100; EN++)
      if (Ei[EN][0])  /* if enemy active */
         {
            int EXint = Ef[EN][0];
            int EYint = Ef[EN][1];
            switch (Ei[EN][0])
            {
               case 1:  /* enemy type 1
                           follows man with no regard
                           to walls or gravity
                           and no checks for out-of-bounds  */
                  if ((Ef[EN][0]) < PXint) (Ef[EN][0]) = (Ef[EN][0]) + Ef[EN][2];
                  if ((Ef[EN][0]) > PXint) (Ef[EN][0]) = (Ef[EN][0]) - Ef[EN][2];
                  if ((Ef[EN][1]) < PYint) (Ef[EN][1]) = (Ef[EN][1]) + Ef[EN][3];
                  if ((Ef[EN][1]) > PYint) (Ef[EN][1]) = (Ef[EN][1]) - Ef[EN][3];
               break;
               case 2: /* enemy type 2
                          follows man with regard
                          to walls , but no gravity
                          Ei[EN][0] = type 2
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] = ans
                          Ei[EN][4] = ans type
                          Ei[EN][5] =
                          Ei[EN][6] =
                          Ei[EN][7] =
                          Ei[EN][8] =
                          Ei[EN][9] = collision box size


                          Ef[EN][1] = x
                          Ef[EN][2] = y
                          Ef[EN][3] = xinc
                          Ef[EN][4] = yinc */

                  if (((Ef[EN][0]) < PXint) && (!is_right_solid(EXint, EYint)))
                     Ef[EN][0] += Ef[EN][2]; /* move right */
                  if (((Ef[EN][0]) > PXint) && (!is_left_solid(EXint, EYint)))
                     Ef[EN][0] -= Ef[EN][2]; /* move left */
                  if (((Ef[EN][1]) < PYint) && (!is_down_solid(EXint, EYint, 1)))
                     Ef[EN][1] += Ef[EN][3]; /* move down */
                  if (((Ef[EN][1]) > PYint) && (!is_up_solid(EXint, EYint, 1, 1)))
                     Ef[EN][1] -= Ef[EN][3]; /* move up */

                     /* set the bitmap and drawing mode */

                          Ei[EN][2] == 0;  /* no flips */
                          b = Ei[EN][3];      /* ans */
                          c = zz[4][b];         /* num_of_shapes in seq */

                          if (Ei[EN][4] == 0) Ei[EN][1] = Ei[EN][3]; /* bmp, not ans */
                          if (Ei[EN][4] == 1) Ei[EN][1] = zz[0][b];    /* animate with time */
                          if (Ei[EN][4] == 2) /* animate with h move */
                             {
                                x = fmod(Ef[EN][0]/3, c);
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 3) /* animate with v move */
                             {
                                x = fmod(Ef[EN][1]/3, c);
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 4) /* animate with v and h move */
                             {
                                x = fmod(Ef[EN][1]/3, c) + fmod(Ef[EN][1]/3, c);
                                while (x > c) x-=c;
                                Ei[EN][1] = zz[x+5][b];
                             }

               break;
               case 3: /* enemy type 3  ArchWag Only
                          follows man with regard
                          to walls and gravity
                          Ei[EN][0] = type 3
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] = ans
                          Ei[EN][4] = ans type
                          Ei[EN][5] = bullet wait (0=none)
                          Ei[EN][6] = jump wait (0=none)
                          Ei[EN][7] = jump when player above
                          Ei[EN][8] = x mode follow(0) or bounce(1)
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc
                          Ef[EN][4] = LIFE decrement
                          Ef[EN][5] = bullet waitcount
                          Ef[EN][6] = bullet prox (0=none)
                          Ef[EN][7] = bullet prox delay
                          Ef[EN][8] = fall and fallcount
                          Ef[EN][9] = jump and jumpcount     */

                  /* bullet wait */
                  if ((Ei[EN][5] > 0) && ((passcount % Ei[EN][5]) == 1)) fire_enemy_x_bullet(EN, EXint, EYint);
                  /* bullet prox */
                  if (Ef[EN][6])
                     {
                        if (Ef[EN][5] > 0) /* if prox wait */
                           {
                              Ef[EN][5]--;   /* dec prox wait */
                              Ei[EN][3] = 3; /* empty wagon ans */
                           }
                        else
                           {
                              Ei[EN][3] = 2; /* arrow wagon ans */
                              if ((Ef[EN][1] > PYint - 5) && (Ef[EN][1] < PYint + 5))
                                 {

                                    if (Ei[EN][2]) /* move right */
                                       if ((EXint > PXint - Ef[EN][6]) && (EXint < PXint) )
                                          {
                                             fire_enemy_x_bullet(EN, EXint, EYint);
                                             Ef[EN][5] = Ef[EN][7]; /* set new prox wait */
                                          }
                                    if (!Ei[EN][2]) /* move left */
                                       if ((EXint > PXint) && (EXint < PXint + Ef[EN][6]))
                                          {
                                             fire_enemy_x_bullet(EN, EXint, EYint);
                                             Ef[EN][5] = Ef[EN][7]; /* set new prox wait */
                                          }
                                 }
                           }
                     }

                  if (!Ei[EN][8]) /* follow mode */
                     {
                        if (EXint < PXint)  /* try to move right */
                           {
                              Ei[EN][2] = 1; /* h_flip */
                              if (!is_right_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] += Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
      
                        if (EXint > PXint)  /* try to move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              if (!is_left_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] -= Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
                     }
                  if (Ei[EN][8]) /* x bounce mode */
                     {
                        if ((Ef[EN][2]) > 0)  /* move right */
                           {
                             Ei[EN][2] = 1; /* h_flip to face right */
                             Ef[EN][0] += Ef[EN][2];
                             EXint=Ef[EN][0];
                             if (is_right_solid(EXint, EYint))
                                {

                                   Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                   Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                   EXint=Ef[EN][0];
                                }
                           }
                        if ((Ef[EN][2]) < 0)  /* move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              Ef[EN][0] += Ef[EN][2];
                              EXint=Ef[EN][0];
                              if (is_left_solid(EXint, EYint))
                                 {

                                    Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                    Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                    EXint=Ef[EN][0];
                                 }
                           }
                     }
                  if (Ef[EN][9])  /*jump*/
                     {
                        Ef[EN][9] -= .05;
                        if (Ef[EN][9] < .1)      /* top of jump */
                           {
                              Ef[EN][9] = 0;    /* jump done */
                              Ef[EN][8] = 1.6;   /* start fall */

                           }
                        else
                           {
                              Ef[EN][1] -= (sin(Ef[EN][9]) * Ef[EN][3]);
                              EYint=Ef[EN][1];
                              if (is_up_solid(EXint, EYint, 1, 1))
                                 {
                                    Ef[EN][9] = 0;   /* abort jump */
                                    Ef[EN][8] = 1.6;   /* start fall */
                                 }
                           }
                     }

                  else  /* not jump */
                     {
                        if (Ef[EN][8])   /* if fall = 1 */
                           {
                              Ef[EN][8] -= .1; /* fall_count = fall_count - .1; */
                              if (Ef[EN][8] < .1)  Ef[EN][8] = .1; /* keep falling at this rate */
                              Ef[EN][1] += (sin(1.6 - Ef[EN][8]) * Ef[EN][3]);
                              if (Ef[EN][1] > 2000) Ef[EN][1]=2000;
                              EYint=Ef[EN][1];
                              if (is_down_solid(EXint, EYint, 1))  /* look for end of fall */
                                 {
                                    Ef[EN][8] = 0; /*  fall=0;  */
                                    Ef[EN][1] -= fmod(Ef[EN][1], 20); /* align with floor */
                                    EYint=Ef[EN][1];
                                 }
                           }
                        if (!Ef[EN][8])  /* fall = 0 */
                           {
                              /* start fall? look for no block below */
                              if (!is_down_solid(EXint, EYint, 1)) Ef[EN][8] = 1.6;

                              /* passcount jump */
                              if ((Ei[EN][7] > 0) && ((passcount % Ei[EN][7]) == 1)) Ef[EN][9] = 1.6; /* jump! */
                              /* jump when player passes over */
                              if ((Ei[EN][6] > 0) && (EXint < (PXint + 15)) && (EXint > (PXint - 15)) && (EYint > PYint)) Ef[EN][9] = 1.6;
                           } /* end of fall = 0  */
                     } /* end of else if not fall  */

                          /* set the bitmap and drawing mode */
                          b = Ei[EN][3];      /* ans */
                          c = zz[4][b];         /* num_of_shapes in seq */

                          if (Ei[EN][4] == 0) Ei[EN][1] = Ei[EN][3]; /* bmp, not ans */
                          if (Ei[EN][4] == 1) Ei[EN][1] = zz[0][b];    /* animate with time */
                          if (Ei[EN][4] == 2) /* animate with h move */
                             {
                                x = (EXint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 3) /* animate with v move */
                             {
                                x = (EYint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 4) /* animate with v and h move */
                             {
                                x = ((EYint/3) % c) + ((EXint/3) % c);
                                if (x > c) x-=c;
                                Ei[EN][1] = zz[x+5][b];
                             }





               break;

               case 4: /* enemy type 4  bouncer !
                          does not follow man!
                   bounces off walls , no gravity
                          Ei[EN][0] = type 4
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] = ans
                          Ei[EN][4] = ans type
                          Ei[EN][5] = main ans
                          Ei[EN][6] = seek ans
                          Ei[EN][7] = bounce counter
                          Ei[EN][8] = bounce count
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc

                          Ef[EN][8] = seek speed
                          Ef[EN][9] = sekk */




                 Ei[EN][3] = Ei[EN][5]; /* main ans by default */
                 if (Ei[EN][8])  /* is seek on? */
                   if (Ei[EN][7] % Ei[EN][8] == 0) /* time to do a seek! */
                     {
                        Ei[EN][3] = Ei[EN][6]; /* seek ans */
                        if (Ef[EN][9] != 1) /* seek 1st time only */
                           {
                              Ef[EN][9] = 1;
                              seek_set_xyinc(EN, EXint, EYint);
                              Ei[EN][2] = 11 + get_rot_from_xyinc(EN);
                           }
                     }
                  else Ef[EN][9]=0;


                  if ((Ef[EN][2]) > 0)  /* move right */
                     {

                       Ef[EN][0] += Ef[EN][2];
                       EXint = Ef[EN][0];
                       if (is_right_solid(EXint, EYint))
                          {
                             Ei[EN][7]++;
                             Ef[EN][2] =- Ef[EN][2]; /* bounce */
                             Ef[EN][0] += Ef[EN][2];
                             EXint = Ef[EN][0];
                             Ei[EN][2] = 11 + get_rot_from_xyinc(EN);
                          }
                     }
                  if ((Ef[EN][2]) < 0)  /* move left */
                     {

                        Ef[EN][0] += Ef[EN][2];
                        EXint = Ef[EN][0];
                        if (is_left_solid(EXint, EYint))
                           {
                              Ei[EN][7]++;
                              Ef[EN][2] =- Ef[EN][2]; /* bounce */
                              Ef[EN][0] += Ef[EN][2];
                              EXint = Ef[EN][0];
                              Ei[EN][2] = 11 + get_rot_from_xyinc(EN);
                           }
                     }
                  if (Ef[EN][3] > 0) /* move down */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        EYint = Ef[EN][1];
                        if (is_down_solid(EXint, EYint, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];
                              Ei[EN][2] = 11 + get_rot_from_xyinc(EN);
                           }
                     }
                  if (Ef[EN][3] < 0)  /* move up */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        EYint = Ef[EN][1];
                        if (is_up_solid(EXint, EYint, 0, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];
                              Ei[EN][2] = 11 + get_rot_from_xyinc(EN);
                           }

                     }
                         /* set the bitmap and drawing mode */

                         /* always with time */
                         Ei[EN][1] = zz[0][Ei[EN][3]];

              break;
              case 5: /* enemy type 5  stationery bullet firer !  */

                    /*    Ei[EN][0] = type 5
                          Ei[EN][1] = !rsvd bitmap
                          Ei[EN][2] = !rsvd draw type
                          Ei[EN][3] =
                          Ei[EN][4] =
                          Ei[EN][5] =
                          Ei[EN][6] = bullet wait
                          Ei[EN][7] =
                          Ei[EN][8] =
                          Ei[EN][9] = collision window

                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] =
                          Ef[EN][3] =
                          Ef[EN][3] = health dec
                          Ef[EN][7] = bullet speed    */

                if ( (passcount % Ei[EN][6]) == (Ei[EN][6])-1)
                   fire_enemy_bulleta(EN, EXint, EYint, 55);


                Ei[EN][2] = 11 + get_rot_from_PXY(EN, EXint, EYint);


                /* set bitmap */
                if ((passcount % Ei[EN][6]) > ((Ei[EN][6] * 7) / 8) ) /* show warning */
                   Ei[EN][1] = 506; /* red cannon */
                else Ei[EN][1] = 507;  /* green cannon */

               break;

               case 6: /* enemy type 6  bouncing cannon !
                          Ei[EN][0] = type 6
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] =
                          Ei[EN][4] =
                          Ei[EN][5] =
                          Ei[EN][6] = bullet_wait
                          Ei[EN][7] = bounce count
                          Ei[EN][8] = seek bounce count wait
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc
                          Ef[EN][7] = bullet speed
                          Ef[EN][8] = seek speed
                          Ef[EN][9] = sekk */

                 if ( (passcount % Ei[EN][6]) == (Ei[EN][6])-1)
                 fire_enemy_bulleta(EN, EXint, EYint, 55);


                 if (Ei[EN][8])  /* is seek on? */
                   if (Ei[EN][7] % Ei[EN][8] == 0) /* time to do a seek! */
                     {

                        if (Ef[EN][9] != 1) /* seek 1st time only */
                           {
                              Ef[EN][9] = 1;
                              seek_set_xyinc(EN, EXint, EYint);

                           }
                     }
                  else Ef[EN][9]=0;
                  Ei[EN][2] = 11 + get_rot_from_PXY(EN, EXint, EYint);
                /* set bitmap */
                if ((passcount % Ei[EN][6]) > ((Ei[EN][6] * 5) / 6) ) /* show warning */
                   {
                      Ei[EN][1] = 506; /* red cannon */
                   }
                else Ei[EN][1] = 507;  /* green cannon */

                  if ((Ef[EN][2]) > 0)  /* move right */
                     {

                       Ef[EN][0] += Ef[EN][2];
                       EXint = Ef[EN][0];
                       if (is_right_solid(EXint, EYint))
                          {
                             Ei[EN][7]++;
                             Ef[EN][2] =- Ef[EN][2]; /* bounce */
                             Ef[EN][0] += Ef[EN][2];


                          }
                     }
                  if ((Ef[EN][2]) < 0)  /* move left */
                     {

                        Ef[EN][0] += Ef[EN][2];
                        EXint = Ef[EN][0];
                        if (is_left_solid(EXint, EYint))
                           {
                              Ei[EN][7]++;
                              Ef[EN][2] =- Ef[EN][2]; /* bounce */
                              Ef[EN][0] += Ef[EN][2];

                           }
                     }
                  if (Ef[EN][3] > 0) /* move down */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        if (is_down_solid(EXint, EYint, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];

                           }
                     }
                  if (Ef[EN][3] < 0)  /* move up */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        if (is_up_solid(EXint, EYint, 0, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];
                           }

                     }
                break;
                case 7:/* Podzilla
                          Ei[EN][0] = type 7
                          Ei[EN][1] = !rsvd bitmap
                          Ei[EN][2] = !rsvd draw type
                          Ei[EN][3] = wait count
                          Ei[EN][4] = wait limit
                          Ei[EN][5] = sequence counter
                          Ei[EN][6] = sequence limit
                          Ei[EN][7] = mode
                          Ei[EN][8] = trigger limit
                          Ei[EN][9] = collision window

                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = x inc
                          Ef[EN][3] = y inc
                          Ef[EN][4] = health dec
                          Ef[EN][5] =
                          Ef[EN][6] =
                          Ef[EN][7] = bullet speed
                          Ef[EN][8] = move speed creator only   */


                  if (!Ei[EN][7]) /* only trigger from mode 0 */
                     if (abs(PXint - EXint) < Ei[EN][8])
                        if (abs(PYint - EYint) < Ei[EN][8])

                           {
                              Ei[EN][7] = 1; /* triggered! mode 1; */
                              Ei[EN][5] = 0;  /* zero counter */
                           }
                  if (Ei[EN][7] == 1) /* mode 1; out */
                     {
                        Ef[EN][0] += Ef[EN][2];
                        Ef[EN][1] += Ef[EN][3];
                        if (++Ei[EN][5] > Ei[EN][6]) /* if (++count > limit) */
                           {
                              Ei[EN][7] = 2; /* next mode */
                              Ei[EN][3] = passcount;
                          }
                     }
                  if (Ei[EN][7] == 2)  /* mode 2; shoot */
                     {
                        if (Ei[EN][3] < (passcount-Ei[EN][4]) )
                           {
                              fire_enemy_bulleta(EN, EXint, EYint, 54);
                              Ei[EN][7] = 3; /* next mode */
                              Ei[EN][3] = passcount;
                           }
                     }
                  if (Ei[EN][7] == 3)  /* mode 4; post shoot pause */
                     {
                        if (Ei[EN][3] < (passcount-Ei[EN][4]) )
                           {
                              Ei[EN][7] = 4; /* next mode */
                              Ei[EN][3] = passcount;
                           }
                     }
                  if (Ei[EN][7] == 4) /* mode 4; in */
                     {
                        Ef[EN][0] -= Ef[EN][2];
                        Ef[EN][1] -= Ef[EN][3];
                        if (--Ei[EN][5] < 1 ) /* if (--count < 1) */
                           {
                              Ei[EN][7] = 0; /* done; back to mode 0 */

                           }
            
                     }


                Ei[EN][1] = zz[ 5 + (Ei[EN][5] * zz[4][15] / Ei[EN][6]) ][15];
                /* bitmap =           counter * numshapes / limit  */
               if ( (Ei[EN][7] == 2) || (Ei[EN][7] == 3) )
                  {
                     Ei[EN][2] = 11 + get_rot_from_PXY(EN, EXint, EYint);
                     Ei[EN][1] = 335; /* green cannon */
                  }
               else   Ei[EN][2] = 11 + get_rot_from_xyinc(EN);


               break;
               case 8: /* enemy type 8  */
               {
                  /* WALL CLIMBER DUDE
                  Ei[EN][0] = type 8
                  Ei[EN][1] = bitmap
                  Ei[EN][2] = draw type
                  Ei[EN][3] = ans
                  Ei[EN][4] = bullet prox re-trigger delay
                  Ei[EN][5] =
                  Ei[EN][6] = mode
                  Ei[EN][7] = fall when player below
                  Ei[EN][8] =
                  Ei[EN][9] = collision box size
   
                  Ef[EN][0] = x
                  Ef[EN][1] = y
                  Ef[EN][2] = xinc
                  Ef[EN][3] = yinc
                  Ef[EN][4] = LIFE decrement
                  Ef[EN][5] = bullet waitcount
                  Ef[EN][6] = bullet prox (0=none)
                  Ef[EN][7] = bullet speed
                  Ef[EN][8] = fall and fallcount
                  Ef[EN][9] =                    */

                  int bullet_request = 0;
                  int mode = Ei[EN][6];
                  int prox = Ef[EN][6];
                  int te = 4;

                  /* bullet prox */
                  if ((prox) && (--Ef[EN][5] < 0)) bullet_request = 1;


                        if (Ef[EN][8])   /* if fall = 1 */
                           {

                              Ef[EN][8] -= .1; /* fall_count = fall_count - .1; */
                              if (Ef[EN][8] < .1)  Ef[EN][8] = .1; /* keep falling at this rate */
                              Ef[EN][1] += (sin(1.6 - Ef[EN][8]) * Ef[EN][3]);
                              if (Ef[EN][1] > 2000) Ef[EN][1]=2000;
                              EYint=Ef[EN][1];
                              if (is_down_solid(EXint, EYint, 1))  /* look for end of fall */
                                 {
                                    Ef[EN][8] = 0; /*  fall=0;  */
                                    Ef[EN][1] -= fmod(Ef[EN][1], 20); /* align with floor */
                                    EYint=Ef[EN][1];
                                 }
                           }
                        if (!Ef[EN][8])  /* if not fall */
                           {
                             if ( (Ei[EN][7]) && (EXint < (PXint + 15)) && (EXint > (PXint - 15))
                               && (EYint < (PYint     )) ) /* if above */

                                {
                                   if (mode == 2)
                                      {
                                         Ef[EN][8] = 1.6; /* fall */
                                         mode = 4;
                                         Ei[EN][2] = 0;
                                      }
                                   if (mode == 6)
                                      {
                                         Ef[EN][8] = 1.6; /* fall */
                                         mode = 0;
                                         Ei[EN][2] = 1;
                                      }
                                
                                }
                           } /* end of fall = 0  */




              if (!Ef[EN][8])  /* not fall */
                 switch (mode)
                  {
                      case 0: /* floor right */
                       if (!is_down_solid(EXint, EYint, 0))
                         {
                            mode = 3;
                            Ef[EN][0] = 19 + (EXint/20)*20;
                            Ef[EN][1] += te;
                            Ei[EN][2] = 42; /* rotation */
                            break;
                         }
                      if (is_right_solid(EXint, EYint))
                         {
                            mode = 1;
                            Ef[EN][0] = (EXint/20)*20;
                            Ei[EN][2] = 234; /* rotation */
                            break;
                         }

                      if (bullet_request)
                         if (EYint >= PYint)
                            if ((EYint-prox) < PYint)
                               if (EXint < PXint)
                                  if ((EXint+prox) > PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 1;
                      Ef[EN][0] += Ef[EN][2];
                      break;


                      case 1: /* rwall up */
                       if (!is_right_solid(EXint, EYint))
                         {
                            mode = 0;
                            Ef[EN][1] = (EYint/20)*20;
                            Ef[EN][0] += te;
                            Ei[EN][2] = 234; /* rotation */
                            break;
                         }
                      if (is_up_solid(EXint, EYint, 0, 0))
                         {
                            mode = 2;
                            Ef[EN][1] = (((EYint+te)/20)*20)-1;
                            Ei[EN][2] = 170; /* rotation */
                            break;
                         }
                      if (bullet_request)
                         if (EYint >= PYint)
                            if ((EYint-prox) < PYint)
                               if (EXint > PXint)
                                  if ((EXint-prox) < PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 202;
                      Ef[EN][1] -= Ef[EN][3];
                      break;


                      case 2: /* ceil left */
                      if (!is_up_solid(EXint, EYint, 0, 0))
                         {
                            mode = 1;
                            Ef[EN][0] = (EXint/20)*20;
                            Ef[EN][1] -= te;
                            Ei[EN][2] = 170; /* rotation */
                            break;
                         }
                    if (is_left_solid(EXint, EYint))
                         {
                            mode = 3;
                            Ef[EN][0] = 19 + (EXint/20)*20;
                            Ei[EN][2] = 106; /* rotation */
                            break;
                         }
                      if (bullet_request)
                         if (EYint < PYint)
                            if ((EYint+prox) > PYint)
                               if (EXint > PXint)
                                  if ((EXint-prox) < PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 138;
                      Ef[EN][0] -= Ef[EN][2];
                      break;
                      case 3: /* lwall down */
                      if (!is_left_solid(EXint, EYint))
                         {
                            mode = 2;
                            Ef[EN][1] = 19 + (EYint/20)*20;
                            Ef[EN][0] -= te;
                            Ei[EN][2] = 106; /* rotation */
                            break;
                         }
                      if (is_down_solid(EXint, EYint, 0))
                         {
                            mode = 0;
                            Ef[EN][1] = (EYint/20)*20;
                            Ei[EN][2] = 170; /* rotation */
                            break;
                         }
                      if (bullet_request)
                         if (EYint < PYint)
                            if ((EYint+prox) > PYint)
                               if (EXint < PXint)
                                  if ((EXint+prox) > PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 74;
                      Ef[EN][1] += Ef[EN][3];
                      break;

                      case 4: /* floor left */
                       if (!is_down_solid(EXint, EYint, 0))
                         {
                            mode = 7;
                            Ef[EN][0] = (EXint/20)*20;
                            Ef[EN][1] += te;
                            Ei[EN][2] = 1224;
                            break;
                         }
                      if (is_left_solid(EXint, EYint))
                         {
                            mode = 5;
                            Ef[EN][0] = 19+((EXint)/20)*20;
                            Ei[EN][2] = 1032;
                            break;
                         }
                      if (bullet_request)
                         if (EYint >= PYint)
                            if ((EYint-prox) < PYint)
                               if (EXint > PXint)
                                  if ((EXint-prox) < PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 0;
                      Ef[EN][0] -= Ef[EN][2];
                      break;


                      case 5: /* lwall up */
                       if (!is_left_solid(EXint, EYint))
                         {
                            mode = 4;
                            Ef[EN][1] = (EYint/20)*20;
                            Ef[EN][0] -= te;
                            Ei[EN][2] = 1032;
                            break;
                         }
                      if (is_up_solid(EXint, EYint, 0, 0))
                         {
                            mode = 6;
                            Ef[EN][1] = (((EYint+te)/20)*20)-1;
                            Ei[EN][2] = 1096;
                            break;
                         }
                      if (bullet_request)
                         if (EYint >= PYint)
                            if ((EYint-prox) < PYint)
                               if (EXint < PXint)
                                  if ((EXint+prox) > PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 1064;
                      Ef[EN][1] -= Ef[EN][3];
                      break;


                      case 6: /* ceil right */
                      if (!is_up_solid(EXint, EYint, 0, 0))
                         {
                            mode = 5;
                            Ef[EN][0] = 19+(EXint/20)*20;
                            Ef[EN][1] -= te;
                            Ei[EN][2] = 1096;
                            break;
                         }
                    if (is_right_solid(EXint, EYint))
                         {
                            mode = 7;
                            Ef[EN][0] = (EXint/20)*20;
                            Ei[EN][2] = 1160;
                            break;
                         }
                      if (bullet_request)
                         if (EYint < PYint)
                            if ((EYint+prox) > PYint)
                               if (EXint < PXint)
                                  if ((EXint+prox) > PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 1128;
                      Ef[EN][0] += Ef[EN][2];
                      break;
                      case 7: /* rwall down */
                      if (!is_right_solid(EXint, EYint))
                         {
                            mode = 6;
                            Ef[EN][1] = 19 + (EYint/20)*20;
                            Ef[EN][0] += te;
                            Ei[EN][2] = 1160;
                            break;
                         }
                      if (is_down_solid(EXint, EYint, 0))
                         {
                            mode = 4;
                            Ef[EN][1] = (EYint/20)*20;
                            Ei[EN][2] = 1224;
                            break;
                         }
                      if (bullet_request)
                         if (EYint < PYint)
                            if ((EYint+prox) > PYint)
                               if (EXint > PXint)
                                  if ((EXint-prox) < PXint)
                                    {
                                       fire_enemy_bulleta(EN, EXint, EYint, 20);
                                       Ef[EN][5] = Ei[EN][4]; /* set new prox wait */
                                    }

                      Ei[EN][2] = 1192;
                      Ef[EN][1] += Ef[EN][3];
                      break;
                   } /* end of switch mode */



                          /* set the bitmap and drawing mode */
                          b = Ei[EN][3];      /* ans */
                          c = zz[4][b];         /* num_of_shapes in seq */

                          if (mode % 2) /* ymove, if odd */
                             {
                                x = (EYint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          else  /* xmove, if even */
                             {
                                x = (EXint/3) % c;
                                if (x > c) x-=c;
                                Ei[EN][1] = zz[x+5][b];
                             }
               if (Ei[EN][6] == mode) Ei[EN][8] = 0;
               if (Ei[EN][6] != mode)
                  {
                     Ei[EN][6] = mode;
                     if (++Ei[EN][8] > 4) /* twirling */
                        {
                           Ef[EN][8] = 1.6; /* fall */
                           Ei[EN][6] = 0;
                           Ei[EN][2] = 1;
                        }
                  }
               }
               break; /* end of case 8 */
               case 9:
                  /* CLONER
                  Ei[EN][0] = type 9
                  Ei[EN][1] = bitmap
                  Ei[EN][2] = draw type
                  Ei[EN][3] = ans
                  Ei[EN][4] =
                  Ei[EN][5] =
                  Ei[EN][6] = create wait
                  Ei[EN][7] = create wait counter
                  Ei[EN][8] =
                  Ei[EN][9] = collision box size
   
                  Ef[EN][0] = x
                  Ef[EN][1] = y
                  Ef[EN][2] = copy box x size
                  Ef[EN][3] = copy box y size
                  Ef[EN][4] = LIFE decrement
                  Ef[EN][5] =
                  Ef[EN][6] = copy box x (2000)
                  Ef[EN][7] = copy box y (2000)
                  Ef[EN][8] = dest box x (2000)
                  Ef[EN][9] = dest box y (2000) */


                  {
                     float ratio = (float) Ei[EN][7] / (float) Ei[EN][6] * 10;
                     b = 9 - (int) ratio;
                     Ei[EN][2] = 1;
                     Ei[EN][1] = zz[5+b][53];
                  }

                  if (--Ei[EN][7] < 0)  /* time for create */
                     {
                        int x1 = Ef[EN][6]-2;    /* source x */
                        int y1 = Ef[EN][7]-2;    /* source y */
                        int x2 = x1 + Ef[EN][2];   /* sizes */
                        int y2 = y1 + Ef[EN][3];

                        int x3 = Ef[EN][8]-2;    /* dest x */
                        int y3 = Ef[EN][9]-2;    /* dest y */
                        int x4 = x3 + Ef[EN][2];   /* sizes */
                        int y4 = y3 + Ef[EN][3];
                        extern BITMAP *scrn_buffer;
                        extern int WX,WY;
                        extern int item[500][16];
                        extern float itemf [500][4];

                        rectfill (scrn_buffer, x1-WX, y1-WY, x2-WX, y2-WY, 10);
                        rectfill (scrn_buffer, x3-WX, y3-WY, x4-WX, y4-WY, 11);

                        Ei[EN][7] = Ei[EN][6]; /* reset counter */
                        Ei[EN][1] = zz[15][53]; /* full red */
             

                        for (b=0; b<100; b++) /* check for enemies in box */
                           if (Ei[b][0])     /* if active */
                              if (Ef[b][0] > x1)
                                 if (Ef[b][0] < x2)
                                    if (Ef[b][1] > y1)
                                       if (Ef[b][1] < y2)
                                          {
                                             /* copy to dest box */
                                             /* find empty */
                                             for (c=0; c<100; c++)
                                                if (Ei[c][0] == 0)
                                                   {
                                                      for (y=0; y<10; y++)
                                                         {
                                                            Ei[c][y] = Ei[b][y];
                                                            Ef[c][y] = Ef[b][y];
                                                         }
                                                      Ef[c][0]= x3 + (Ef[b][0]-x1);
                                                      Ef[c][1]= y3 + (Ef[b][1]-y1);
                                                      c = 100; /* end loop */
                                                   }
                                          }

                        for (b=0; b<500; b++) /* check for items in box */
                           if (item[b][0])     /* if active */
                              if (itemf[b][0] > x1)
                                 if (itemf[b][0] < x2)
                                    if (itemf[b][1] > y1)
                                       if (itemf[b][1] < y2)
                                          {
                                             /* copy to dest box */
                                             /* find empty */
                                             for (c=0; c<500; c++)
                                                if (item[c][0] == 0)
                                                   {
                                                      for (y=0; y<16; y++)
                                                         item[c][y] = item[b][y];

                                                      itemf[c][0]= x3 + (itemf[b][0]-x1);
                                                      itemf[c][1]= y3 + (itemf[b][1]-y1);
                                                      itemf[c][2]= 0;
                                                      itemf[c][3]= 0;


                                                      c = 500; /* end loop */
                                                   }
                                          }
                     }
               break;
         case 10: /* enemy type 10  like ArchWag
                          follows man with regard
                          to walls and gravity
                          Ei[EN][0] = type 3
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] = ans
                          Ei[EN][4] = ans type
                          Ei[EN][5] =
                          Ei[EN][6] = jump wait (0=none)
                          Ei[EN][7] = jump when player above
                          Ei[EN][8] = x mode follow(0) or bounce(1)
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc
                          Ef[EN][4] = LIFE decrement
                          Ef[EN][5] =
                          Ef[EN][6] =
                          Ef[EN][7] =
                          Ef[EN][8] = fall and fallcount
                          Ef[EN][9] = jump and jumpcount     */


                  if (!Ei[EN][8]) /* follow mode */
                     {
                        if (EXint < PXint)  /* try to move right */
                           {
                              Ei[EN][2] = 1; /* h_flip */
                              if (!is_right_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] += Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
      
                        if (EXint > PXint)  /* try to move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              if (!is_left_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] -= Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
                     }
                  if (Ei[EN][8]) /* x bounce mode */
                     {
                        if ((Ef[EN][2]) > 0)  /* move right */
                           {
                             Ei[EN][2] = 1; /* h_flip to face right */
                             Ef[EN][0] += Ef[EN][2];
                             EXint=Ef[EN][0];
                             if (is_right_solid(EXint, EYint))
                                {

                                   Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                   Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                   EXint=Ef[EN][0];
                                }
                           }
                        if ((Ef[EN][2]) < 0)  /* move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              Ef[EN][0] += Ef[EN][2];
                              EXint=Ef[EN][0];
                              if (is_left_solid(EXint, EYint))
                                 {

                                    Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                    Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                    EXint=Ef[EN][0];
                                 }
                           }
                     }
                  if (Ef[EN][9])  /*jump*/
                     {
                        Ef[EN][9] -= .05;
                        if (Ef[EN][9] < .1)      /* top of jump */
                           {
                              Ef[EN][9] = 0;    /* jump done */
                              Ef[EN][8] = 1.6;   /* start fall */

                           }
                        else
                           {
                              Ef[EN][1] -= (sin(Ef[EN][9]) * Ef[EN][3]);
                              EYint=Ef[EN][1];
                              if (is_up_solid(EXint, EYint, 1, 1))
                                 {
                                    Ef[EN][9] = 0;   /* abort jump */
                                    Ef[EN][8] = 1.6;   /* start fall */
                                 }
                           }
                     }

                  else  /* not jump */
                     {
                        if (Ef[EN][8])   /* if fall = 1 */
                           {
                              Ef[EN][8] -= .1; /* fall_count = fall_count - .1; */
                              if (Ef[EN][8] < .1)  Ef[EN][8] = .1; /* keep falling at this rate */
                              Ef[EN][1] += (sin(1.6 - Ef[EN][8]) * Ef[EN][3]);
                              if (Ef[EN][1] > 2000) Ef[EN][1]=2000;
                              EYint=Ef[EN][1];
                              if (is_down_solid(EXint, EYint, 1))  /* look for end of fall */
                                 {
                                    Ef[EN][8] = 0; /*  fall=0;  */
                                    Ef[EN][1] -= fmod(Ef[EN][1], 20); /* align with floor */
                                    EYint=Ef[EN][1];
                                 }
                           }
                        if (!Ef[EN][8])  /* fall = 0 */
                           {
                              /* start fall? look for no block below */
                              if (!is_down_solid(EXint, EYint, 1)) Ef[EN][8] = 1.6;

                              /* passcount jump */
                              if ((Ei[EN][7] > 0) && ((passcount % Ei[EN][7]) == 1)) Ef[EN][9] = 1.6; /* jump! */
                              /* jump when player passes over */
                              if ((Ei[EN][6] > 0) && (EXint < (PXint + 15)) && (EXint > (PXint - 15)) && (EYint > PYint)) Ef[EN][9] = 1.6;
                           } /* end of fall = 0  */
                     } /* end of else if not fall  */

                          /* set the bitmap and drawing mode */
                          b = Ei[EN][3];      /* ans */
                          c = zz[4][b];         /* num_of_shapes in seq */

                          if (Ei[EN][4] == 0) Ei[EN][1] = Ei[EN][3]; /* bmp, not ans */
                          if (Ei[EN][4] == 1) Ei[EN][1] = zz[0][b];    /* animate with time */
                          if (Ei[EN][4] == 2) /* animate with h move */
                             {
                                x = (EXint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 3) /* animate with v move */
                             {
                                x = (EYint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 4) /* animate with v and h move */
                             {
                                x = ((EYint/3) % c) + ((EXint/3) % c);
                                if (x > c) x-=c;
                                Ei[EN][1] = zz[x+5][b];
                             }


               break;
         case 11: /* enemy type 11  like ArchWag
                          follows man with regard
                          to walls and gravity
                          Ei[EN][0] = type 11
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] = ans
                          Ei[EN][4] = ans type
                          Ei[EN][5] =
                          Ei[EN][6] = jump wait (0=none)
                          Ei[EN][7] = jump when player above
                          Ei[EN][8] = x mode follow(0) or bounce(1)
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc
                          Ef[EN][4] = LIFE decrement
                          Ef[EN][5] =
                          Ef[EN][6] =
                          Ef[EN][7] =
                          Ef[EN][8] = fall and fallcount
                          Ef[EN][9] = jump and jumpcount     */


                  if (!Ei[EN][8]) /* follow mode */
                     {
                        if (EXint < PXint)  /* try to move right */
                           {
                              Ei[EN][2] = 1; /* h_flip */
                              if (!is_right_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] += Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
      
                        if (EXint > PXint)  /* try to move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              if (!is_left_solid(EXint, EYint))
                                 {
                                    Ef[EN][0] -= Ef[EN][2];
                                    EXint = Ef[EN][0];
                                 }
                           }
                     }
                  if (Ei[EN][8]) /* x bounce mode */
                     {
                        if ((Ef[EN][2]) > 0)  /* move right */
                           {
                             Ei[EN][2] = 1; /* h_flip to face right */
                             Ef[EN][0] += Ef[EN][2];
                             EXint=Ef[EN][0];
                             if (is_right_solid(EXint, EYint))
                                {

                                   Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                   Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                   EXint=Ef[EN][0];
                                }
                           }
                        if ((Ef[EN][2]) < 0)  /* move left */
                           {
                              Ei[EN][2] = 0; /* no h_flip */
                              Ef[EN][0] += Ef[EN][2];
                              EXint=Ef[EN][0];
                              if (is_left_solid(EXint, EYint))
                                 {

                                    Ef[EN][2] =- Ef[EN][2]; /* bounce */
                                    Ef[EN][0] += Ef[EN][2]; /* take back last move */
                                    EXint=Ef[EN][0];
                                 }
                           }
                     }
                  if (Ef[EN][9])  /*jump*/
                     {
                        Ef[EN][9] -= .05;
                        if (Ef[EN][9] < .1)      /* top of jump */
                           {
                              Ef[EN][9] = 0;    /* jump done */
                              Ef[EN][8] = 1.6;   /* start fall */

                           }
                        else
                           {
                              Ef[EN][1] -= (sin(Ef[EN][9]) * Ef[EN][3]);
                              EYint=Ef[EN][1];
                              if (is_up_solid(EXint, EYint, 1, 1))
                                 {
                                    Ef[EN][9] = 0;   /* abort jump */
                                    Ef[EN][8] = 1.6;   /* start fall */
                                 }
                           }
                     }

                  else  /* not jump */
                     {
                        if (Ef[EN][8])   /* if fall = 1 */
                           {
                              Ef[EN][8] -= .1; /* fall_count = fall_count - .1; */
                              if (Ef[EN][8] < .1)  Ef[EN][8] = .1; /* keep falling at this rate */
                              Ef[EN][1] += (sin(1.6 - Ef[EN][8]) * Ef[EN][3]);
                              if (Ef[EN][1] > 2000) Ef[EN][1]=2000;
                              EYint=Ef[EN][1];
                              if (is_down_solid(EXint, EYint, 1))  /* look for end of fall */
                                 {
                                    Ef[EN][8] = 0; /*  fall=0;  */
                                    Ef[EN][1] -= fmod(Ef[EN][1], 20); /* align with floor */
                                    EYint=Ef[EN][1];
                                 }
                           }
                        if (!Ef[EN][8])  /* fall = 0 */
                           {
                              /* start fall? look for no block below */
                              if (!is_down_solid(EXint, EYint, 1)) Ef[EN][8] = 1.6;

                              /* passcount jump */
                              if ((Ei[EN][7] > 0) && ((passcount % Ei[EN][7]) == 1)) Ef[EN][9] = 1.6; /* jump! */
                              /* jump when player passes over */
                              if ((Ei[EN][6] > 0) && (EXint < (PXint + 15)) && (EXint > (PXint - 15)) && (EYint > PYint)) Ef[EN][9] = 1.6;
                           } /* end of fall = 0  */
                     } /* end of else if not fall  */

                          /* set the bitmap and drawing mode */
                          b = Ei[EN][3];      /* ans */
                          c = zz[4][b];         /* num_of_shapes in seq */

                          if (Ei[EN][4] == 0) Ei[EN][1] = Ei[EN][3]; /* bmp, not ans */
                          if (Ei[EN][4] == 1) Ei[EN][1] = zz[0][b];    /* animate with time */
                          if (Ei[EN][4] == 2) /* animate with h move */
                             {
                                x = (EXint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 3) /* animate with v move */
                             {
                                x = (EYint/3) % c;
                                Ei[EN][1] = zz[x+5][b];
                             }
                          if (Ei[EN][4] == 4) /* animate with v and h move */
                             {
                                x = ((EYint/3) % c) + ((EXint/3) % c);
                                if (x > c) x-=c;
                                Ei[EN][1] = zz[x+5][b];
                             }


               break;
               case 12: /* enemy type 12  multiple hit bouncing cannon !
                          Ei[EN][0] = type 12
                          Ei[EN][1] = bitmap
                          Ei[EN][2] = draw type
                          Ei[EN][3] =
                          Ei[EN][4] =
                          Ei[EN][5] =
                          Ei[EN][6] = bullet_wait
                          Ei[EN][7] = bounce count
                          Ei[EN][8] = seek bounce count wait
                          Ei[EN][9] = collision box size


                          Ef[EN][0] = x
                          Ef[EN][1] = y
                          Ef[EN][2] = xinc
                          Ef[EN][3] = yinc
                          Ef[EN][7] = bullet speed
                          Ef[EN][8] = seek speed
                          Ef[EN][9] = sekk */

                 if ( (passcount % Ei[EN][6]) == (Ei[EN][6])-1)
                 fire_enemy_bulleta(EN, EXint, EYint, 55);


                 if (Ei[EN][8])  /* is seek on? */
                   if (Ei[EN][7] % Ei[EN][8] == 0) /* time to do a seek! */
                     {

                        if (Ef[EN][9] != 1) /* seek 1st time only */
                           {
                              Ef[EN][9] = 1;
                              seek_set_xyinc(EN, EXint, EYint);

                           }
                     }
                  else Ef[EN][9]=0;
                  Ei[EN][2] = 11 + get_rot_from_PXY(EN, EXint, EYint);
                /* set bitmap */
                if ((passcount % Ei[EN][6]) > ((Ei[EN][6] * 5) / 6) ) /* show warning */
                   {
                      Ei[EN][1] = 506; /* red cannon */
                   }
                else Ei[EN][1] = 507;  /* green cannon */

                  if ((Ef[EN][2]) > 0)  /* move right */
                     {

                       Ef[EN][0] += Ef[EN][2];
                       EXint = Ef[EN][0];
                       if (is_right_solid(EXint, EYint))
                          {
                             Ei[EN][7]++;
                             Ef[EN][2] =- Ef[EN][2]; /* bounce */
                             Ef[EN][0] += Ef[EN][2];


                          }
                     }
                  if ((Ef[EN][2]) < 0)  /* move left */
                     {

                        Ef[EN][0] += Ef[EN][2];
                        EXint = Ef[EN][0];
                        if (is_left_solid(EXint, EYint))
                           {
                              Ei[EN][7]++;
                              Ef[EN][2] =- Ef[EN][2]; /* bounce */
                              Ef[EN][0] += Ef[EN][2];

                           }
                     }
                  if (Ef[EN][3] > 0) /* move down */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        if (is_down_solid(EXint, EYint, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];

                           }
                     }
                  if (Ef[EN][3] < 0)  /* move up */
                     {
                        Ef[EN][1] += Ef[EN][3];
                        if (is_up_solid(EXint, EYint, 0, 1))
                           {
                              Ei[EN][7]++;
                              Ef[EN][3] =- Ef[EN][3]; /* bounce */
                              Ef[EN][1] += Ef[EN][3];
                           }

                     }
                break;


            }  /* end of switch case */
         } /* end of if enemy active */
} /*  end of void enemy_move(void) */


player_move()
{
   /* X-MOVE  */
   if ((key[left_key]) || (joy_left))
      {
         left_right = 0;
         if (left_speed < initial_x_speed) left_speed = initial_x_speed;
         else
            {
               left_speed += accel;
               if (left_speed > max_x_speed) left_speed = max_x_speed;
            }
      }
   else
      {
         left_speed -= de_accel;
         if (left_speed < 0) left_speed = 0;
      }
   if ((key[right_key]) || (joy_right))
      {
         left_right = 1;
         if (right_speed < initial_x_speed) right_speed = initial_x_speed;
         else
            {
               right_speed += accel;
               if (right_speed > max_x_speed) right_speed = max_x_speed;
            }
      }
   else
      {
         right_speed -= de_accel;
         if (right_speed < 0) right_speed = 0;
      }
   p_xmove = right_speed - left_speed;
   PXint = PX + p_xmove;
   PYint = PY;

   /* check for player being pushed by lift */
   a = (is_left_solid(PXint,PYint));
   if ( a > 31 )
      {
         p_xmove += mov_obf[a-32][2] + left_speed;
         left_speed=0;
      }
   a = is_right_solid(PXint,PYint);
   if ( a > 31 )
      {
         p_xmove += mov_obf[a-32][2] - right_speed;
         right_speed = 0;
      }
   /* check if trying to move through wall */
   if ((p_xmove > 0) && (!is_right_solid(PXint+ (int) p_xmove,PYint)) )
            {
               PX += p_xmove;
               if (PX>1980) PX=1980;
               PXint = PX;
            }
   if ((p_xmove < 0) && (!is_left_solid(PXint+ (int) p_xmove,PYint)) )
            {
               PX += p_xmove;
               if (PX<0) PX=0;
               PXint = PX;
            }
   /* Y MOVEMENT   */
   /* check if in the middle of a jump */
   if (jump_count)
      {
         jump_count -= jump_sinc;
         if (jump_count < .1)
            {
               jump_count = 0;
               fall_count = 1.57;
            }
         else
            {
               if (!jump) jump_count -= (jump_sinc*4); /* jump released */
               if (is_up_solid(PXint, PYint, 1, 1))
                  {
                     jump_count = 0;
                     fall_count = 1.57;
                  }
               else PY -= (sin(jump_count) * pmovey);
            }
      }
   else   /* not jump  */
      {
         if (fall_count)
            {
               fall_count -= fall_sinc;
               if (fall_count < .1) fall_count = .1;
               PY += (sin(1.57 - fall_count) * pmovey);
               PYint = PY;
               a = is_down_solid(PXint,PYint, 1);
               if (a == 1)
                  {
                     fall_count = 0;
                     PY -= fmod (PY, 20); /* align with floor */
                  }
               if (a > 31) /* on lift */
                  {
                     fall_count = 0;
                     player_ride = a; /* lift num */
                  }
            }
         else /* not jump or fall */
            {
               a = is_down_solid(PXint,PYint, 1); /* on lift? */
               if (a > 31)
               if (!((player_carry) && (item[player_carry-32][0] != 98)))

                  {
                     player_ride = a ; /* number of shape he's riding */
                     if (mov_obf[a-32][3] < 0) /* yinc (up) */
                        {
                           PYint = PY + mov_obf[a-32][3];
                           if (is_up_solid(PXint, PYint, 1, 1))  /* hit ceiling? */
                              {
                                 player_ride = 0;    /* fall off lift */
                                 fall_count = 1.57;
                                 PY += 5; /* set y so he falls*/
                              }
                        }
                     if (mov_obf[player_ride - 32][3] > 0) /* yinc (down)*/
                        {
                           PYint = PY + mov_obf[player_ride - 32][3];
                           if (is_down_solid(PXint, PYint, 0))  /* floor below? */
                              {
                                 player_ride = 0;   /* off lift */
                                 fall_count = 1.57;
                                 PY -= 5; /* set y */
                              }
                        }
                  }
               if (a == 0)  /* start fall? */
                  {
                     player_ride = 0;
                     fall_count = 1.57;
                  }
               if ((a) && (jump)) /* check if jump pressed  */
                  {
                     player_ride = 0;
                     jump_count=1.57;
                  }
            }
      } /* end of else not jump and end of Y_MOVE */
}
draw_player()
{
   PXint = PX;
   PYint = PY;
   b = 9;

   if ((key[up_key]) || (joy_up))   b=10;
   if ((key[down_key]) || (joy_down)) b=11;

   x = (PXint/4) % zz[4][b];
   if ((jump_count) || (fall_count)) x = 0;
   if ((player_ride) && (right_speed<.5) && (left_speed<.5)) x = 0;
   y = zz[x+5][b];

   if (left_right) draw_sprite(scrn_buffer, memory_bitmap[y], PXint-WX, PYint-WY);
   else draw_sprite_h_flip(scrn_buffer, memory_bitmap[y], PXint-WX, PYint-WY);
   if (map100_on)
      {
        /*  rectfill(map100_bmp,((PXint+10)/20)-1, (PYint/20)-1,((PXint+10)/20)+1, (PYint/20)+1,152);
          */

         if ((passcount % 20) < 10 )
            {
               putpixel(map100_bmp,((PXint+10)/20)+1, (PYint/20),74);
               putpixel(map100_bmp,((PXint+10)/20)-1, (PYint/20),74);
               putpixel(map100_bmp,((PXint+10)/20), (PYint/20)+1,74);
               putpixel(map100_bmp,((PXint+10)/20), (PYint/20)-1,74);
            }
         if ((passcount % 20) > 9 )
            {
               putpixel(map100_bmp,((PXint+10)/20)+1, (PYint/20)+1,74);
               putpixel(map100_bmp,((PXint+10)/20)-1, (PYint/20)-1,74);
               putpixel(map100_bmp,((PXint+10)/20)+1, (PYint/20)-1,74);
               putpixel(map100_bmp,((PXint+10)/20)-1, (PYint/20)+1,74);
            }


          putpixel(map100_bmp,((PXint+10)/20), (PYint/20),10);
         
      }
}


move_lifts()
{
   for (d=0; d<20; d++)
      if (mov_ob[d][0]) /* if active */
         {
            int next_mode = 0;
            mov_obf[d][0] += mov_obf[d][2]; /* xinc */
            mov_obf[d][1] += mov_obf[d][3]; /* yinc */
            if (d == player_ride-32)
               {
                  PXint = PX;
                  PYint = PY;
                  if ((mov_obf[d][2] > 0) && (!is_right_solid(PXint,PYint)) )
                     {
                        PX += mov_obf[d][2];
                        if (PX>1980) PX=1980;
                     }
                  if ((mov_obf[d][2] < 0) && (!is_left_solid(PXint,PYint)) )
                     {
                        PX += mov_obf[d][2];
                        if (PX<0) PX=0;
                     }
                  PY = mov_obf[d][1]-20; /* align with Y1 */
               }
            mov_ob[d][2] = mov_obf[d][0]; /* put as int in x1 */
            mov_ob[d][3] = mov_obf[d][1]; /* put as int in y1 */
            mov_ob[d][4] = mov_ob[d][2] + (mov_ob[d][10]*20)-1; /* width  */
            mov_ob[d][5] = mov_ob[d][3] + (mov_ob[d][11]*20)-1; /* height */
   
            /* limits */
            switch (mov_ob[d][9]) /* limit type */
               {
                  case 5: /* timer wait */
                          if (--mov_ob[d][8] < 0)
                          next_mode = 1;
                  break;
                  case 6: /* prox wait */
                     {
                        int bx1 = ((mov_ob[d][2]+ mov_ob[d][4])/2)- mov_ob[d][8];
                        int by1 = ((mov_ob[d][3]+ mov_ob[d][5])/2)- mov_ob[d][8];
                        int bx2 = ((mov_ob[d][2]+ mov_ob[d][4])/2)+ mov_ob[d][8];
                        int by2 = ((mov_ob[d][3]+ mov_ob[d][5])/2)+ mov_ob[d][8];
                        if ( (PX > bx1) && (PX < bx2) && (PY > by1) && (PY < by2) )
                           next_mode = 1;
                     }
                  break;
                  case 7: /* step count */
                          if (--mov_ob[d][8] < 0)
                          next_mode = 1;
                  break;
               }
            if (next_mode)
               {
                  int step = ++mov_ob[d][6];
                  next_mode = 0;
                  switch (mov_obi[d][step][3])
                     {
                        case 1: /* move */
                           {
                              float speed, angle, xlen, ylen, xinc, yinc;
                              speed = mov_obi[d][step][2];
                              speed /=10;
                              xlen = abs( mov_ob[d][2] - mov_obi[d][step][0] );
                              if (xlen == 0) xlen = .000001;
                              ylen = abs( mov_ob[d][3] - mov_obi[d][step][1] );
                              if (ylen == 0) ylen = .000001;
                              angle = atan(ylen/xlen);
                              xinc = cos(angle) * speed;
                              yinc = sin(angle) * speed;
                              if (xlen > ylen)
                                 mov_ob[d][8] = abs( xlen / xinc); /* distance/speed=time! */
                              if (xlen <= ylen)
                                 mov_ob[d][8] = abs( ylen / yinc); /* distance/speed=time! */
                              mov_ob[d][9] = 7; /* step countdown limit type 7 */
   
                              if (mov_ob[d][2] < mov_obi[d][step][0]) mov_obf[d][2] = +xinc;
                              if (mov_ob[d][2] == mov_obi[d][step][0]) mov_obf[d][2] = 0;
                              if (mov_ob[d][2] > mov_obi[d][step][0]) mov_obf[d][2] = -xinc;
   
                              if (mov_ob[d][3] < mov_obi[d][step][1]) mov_obf[d][3] = +yinc;
                              if (mov_ob[d][3] == mov_obi[d][step][1]) mov_obf[d][3] = 0;
                              if (mov_ob[d][3] > mov_obi[d][step][1]) mov_obf[d][3] = -yinc;
                           }
                        break;
                        case 2: /* wait time */
                           mov_ob[d][9] = 5; /* time is limit type 5 */
                           mov_ob[d][8] = mov_obi[d][step][2]; /* limit */
                           mov_obf[d][2] = 0; /* no xinc */
                           mov_obf[d][3] = 0; /* no yinc */
                        break;
   
   
                        case 3: /* wait prox */
                           mov_ob[d][9] = 6; /* wait prox is limit type 6 */
                           mov_ob[d][8] = mov_obi[d][step][2]; /* limit */
                           mov_obf[d][2] = 0; /* no xinc */
                           mov_obf[d][3] = 0; /* no yinc */
                 
   
                        break;
                        case 4: /* move to step 0 */
                           {
                              float speed, angle, xlen, ylen, xinc, yinc;
                              step = mov_ob[d][6] = 0; /* set step 0 */
                              speed = (float) mov_obi[d][step][2]/10;
   
                              xlen = abs( mov_ob[d][2] - mov_obi[d][step][0] );
                              if (xlen == 0) xlen = .000001;
                              ylen = abs( mov_ob[d][3] - mov_obi[d][step][1] );
                              if (ylen == 0) ylen = .000001;
                              angle = atan(ylen/xlen);
                              xinc = cos(angle) * speed;
                              yinc = sin(angle) * speed;
                              if (xlen > ylen)
                                 mov_ob[d][8] = abs( xlen / xinc); /* distance/speed=time! */
                              if (xlen <= ylen)
                                 mov_ob[d][8] = abs( ylen / yinc); /* distance/speed=time! */
                              mov_ob[d][9] = 7; /* step countdown limit type 7 */
   
                              if (mov_ob[d][2] < mov_obi[d][step][0]) mov_obf[d][2] = +xinc;
                              if (mov_ob[d][2] == mov_obi[d][step][0]) mov_obf[d][2] = 0;
                              if (mov_ob[d][2] > mov_obi[d][step][0]) mov_obf[d][2] = -xinc;
   
                              if (mov_ob[d][3] < mov_obi[d][step][1]) mov_obf[d][3] = +yinc;
                              if (mov_ob[d][3] == mov_obi[d][step][1]) mov_obf[d][3] = 0;
                              if (mov_ob[d][3] > mov_obi[d][step][1]) mov_obf[d][3] = -yinc;
                           }
                        break;
                     } /* end of switch case */
               }  /* end of if (next_mode)  */
         } /* end of if (active) */
}
draw_lifts()
{
   for (d=0; d<20; d++)
      if (mov_ob[d][0])
         {
            extern char level_text[100][40];
            int x1 = mov_ob[d][2];
            int x2 = mov_ob[d][4];
            int y1 = mov_ob[d][3];
            int y2 = mov_ob[d][5];
            int mode = mov_ob[d][6];
            int color = mov_ob[d][12];
            int text_line = mov_ob[d][13]-1;
            if (map100_on)
               {
                  if (y2-y1 > 20) rect(map100_bmp, x1/20, y1/20, x2/20, -1 + y2/20, mov_ob[d][12]);
                  else hline(map100_bmp, x1/20, y1/20, x2/20, mov_ob[d][12]); /* single line */
               }
            for (a=0; a<10; a++)
               rect(scrn_buffer, x1-WX+a, y1-WY+a, x2-WX-a, y2-WY-a, color + ((9 - a)*16) );
            rectfill(scrn_buffer, x1-WX+a, y1-WY+a, x2-WX-a, y2-WY-a, color );
            if (text_line) textout_centre(scrn_buffer, font, level_text[text_line], ((x1+x2)/2)-WX, ((y1+y2)/2)-WY-2, color+160);
            else
               {
                  sprintf(msg, "lift #%d", d);
                  textout_centre(scrn_buffer, font, msg, ((x1+x2)/2)-WX, ((y1+y2)/2)-WY-2, color+160);
               }
         }  /* end of draw lift */
}
enemy_draw_and_collision(void)
{
   int nec = 0;
   for (e = 0; e < 100; e++)
      if (Ei[e][0])  /* if enemy active */
         {
            int EXint = Ef[e][0];
            int EYint = Ef[e][1];
            nec++;
            for (c=0; c<50; c++)  /* check all bullets */
               if (pbullet[c][0]) /* if active */
                {
                  a = abs(pbullet[c][4]/2) + pm_bullet_collision_box; /* bullet stretch collision box size */
                  b = abs(pbullet[c][5]/2) + pm_bullet_collision_box;
                     if (abs(pbullet[c][2] - EXint) < a)
                        if (abs(pbullet[c][3] - EYint) < b)
                                {
                                    /* enemy dies from bullet wound */

                                    if (Ei[e][0] == 11) /* H block! */
                                       {
                                          int tx = EXint/20;
                                          int ty = EYint/20;
                                          l[tx][ty] = 168;

                                          blit(memory_bitmap[168], level_2000, 0, 0, (tx*20), (ty*20), 20, 20);
                                          putpixel(map100_bkg, tx, ty, 8);


                                       }

                                    bottom_msg = 120;
                                    if (sound_on) play_sample( snd[14], 200, 127, 1200, 0);
                                    sprintf(b_msg, "enemy killed!...%d left", num_enemy-1);
                                    Ei[e][0] = 0; /* set to inactive */
                                    pbullet[c][0] = 0; /* bullet dies too */

                                 }
               }
            b = Ei[e][9]; /* collision box size */

            if (PXint > (EXint -b)) /* check for collision with player */
               if (PXint < (EXint +b))
                  if (PYint > (EYint -b))
                     if (PYint < (EYint +b))
                        {
                           /* player loses some LIFE */
                           bottom_msg = 10;
                           if (sound_on) play_sample( snd[13], 127, 127, 1000, 0);
                           sprintf(b_msg, "You got hit!");
                           LIFE -= Ef[e][4]*( (float) dif/4 );
                        }
              /* check for on screen */
              if (EXint > WX - 20)
                 if (EXint < WX + SCREEN_W)
                    if (EYint > WY - 20)
                       if (EYint < WY + SCREEN_H)
                          {
                             BITMAP *dtemp;
                             dtemp = create_bitmap(20,20);
                             clear(dtemp);

                             c = Ei[e][1]; /* bitmap set by enemy_move */
                             blit(memory_bitmap[c], dtemp, 0, 0, 0, 0, 20, 20);


                             if (Ei[e][2] == 0) draw_sprite_h_flip(scrn_buffer, dtemp, EXint-WX, EYint-WY);
                             if (Ei[e][2] == 1) draw_sprite(scrn_buffer, dtemp, EXint-WX, EYint-WY);
                             if (Ei[e][2] == 2) draw_sprite_v_flip(scrn_buffer, dtemp, EXint-WX, EYint-WY);
                             if (Ei[e][2] == 3) draw_sprite_vh_flip(scrn_buffer, dtemp, EXint-WX, EYint-WY);

                             if ((Ei[e][2] > 10) && (Ei[e][2] < 500))
                                {
                                   fixed fixed_angle;
                                   fixed_angle = itofix(Ei[e][2] -10);
                                   rotate_sprite(scrn_buffer, dtemp, EXint-WX, EYint-WY, fixed_angle);
                                }
                             if (Ei[e][2] > 999)
                                {
                                   BITMAP *ctemp;
                                   fixed fixed_angle;
                                   fixed_angle = itofix(Ei[e][2] - 1000);
                                   ctemp = create_bitmap(20,20);
                                   clear(ctemp);
                                   draw_sprite_h_flip(ctemp, dtemp, 0, 0);
                                   rotate_sprite(scrn_buffer, ctemp, EXint-WX, EYint-WY, fixed_angle);
                                   destroy_bitmap(ctemp);
                                }
                             destroy_bitmap(dtemp);
                            
                           }
              if (map100_on) putpixel(map100_bmp, (EXint/20), (EYint/20), map_enemy_color);
         } /* end of if active */
   num_enemy=nec; /* this function uses num_enemy so...*/
}
proc_pbullets()
{
   request_bullet=0;
   if ( (fire) && (!fire_held) && (!bullet_wait_counter)) /* fire button pressed */
      {
         if (num_bullets > 0)
            {
               request_bullet = 1;
               bullet_wait_counter = bullet_wait;
               fire_held=1;
            }
         else
            {
               bottom_msg = 120;
               sprintf(b_msg, "No bullets!");
            }
      }
   else if (--bullet_wait_counter < 0) bullet_wait_counter = 0;
   for (b = 0; b < 50; b++)
      {
         if (pbullet[b][0])  /* if bullet not active skip to next one */
            {
               pbullet[b][2] += pbullet[b][4];  /* xinc */
               pbullet[b][3] += pbullet[b][5];  /* yinc */
               if ((pbullet[b][2] < 0) || (pbullet[b][2] > 2000) || (pbullet[b][3]<0) || (pbullet[b][3] > 2000) )
                  pbullet[b][0];
               x = ( (pbullet[b][2] + 10) / 20);
               y = ( (pbullet[b][3] + 10) / 20);
               d = l[x][y];
               if ((d > 15) && (d < 256)) /* if hit solid or breakable */
                  {
                     pbullet[b][0] = 0;  /* bullet dies  */
                     if ((d > 23) && (d < 32)) /* breakable wall */
                        {
                           l[x][y] = 0; /* wall dies too */
                           blit(memory_bitmap[0], level_2000, 0, 0, (x*20), (y*20), 20, 20);
                           putpixel(map100_bkg, x, y, map_empty_color);
                        }
                  }
            draw_sprite(scrn_buffer, memory_bitmap[zz[0][4]], pbullet[b][2]-WX, pbullet[b][3]-WY);
            if (map100_on) putpixel(map100_bmp, pbullet[b][2]/20, pbullet[b][3]/20, map_bullet_color);
            }
         else if (request_bullet)
            {
                      /* setting initial...*/
                      if (sound_on) play_sample( snd[0], 180, 127, 800, 0);
                      pbullet[b][0] = 1;
                      pbullet[b][2] = PXint;
                      pbullet[b][3] = PYint + 1;
                      pbullet[b][4] = 0; /* xinc */
                      pbullet[b][5] = 0; /* yinc */
                      num_bullets--;
                      if ((key[up_key]) || (joy_up))
                         {
                            pbullet[b][5] = -bullet_speed;
                            pbullet[b][2] = -5 + PXint + (left_right*10);
                         }
                      else if ((key[down_key]) || (joy_down))
                         {
                            pbullet[b][5] = bullet_speed;
                            pbullet[b][2] = -5 + PXint + (left_right*10);
                         }
                      else pbullet[b][4] = (left_right * (bullet_speed*2) ) - bullet_speed;
                      request_bullet = 0;
            }
      }
}
proc_ebullets()
{
   for (b = 0; b < 50; b++)
      if (e_bullet_active[b])  /* if bullet not active skip to next one */
         {
            int ex, ey;
            e_bullet_x[b] += e_bullet_xinc[b]; /* inc x */
            e_bullet_y[b] += e_bullet_yinc[b]; /* inc y */
            ex = e_bullet_x[b];
            ey = e_bullet_y[b];
            if ((ex<0) || (ex>2000) || (ey<0) || (ey>2000))
               e_bullet_active[b] = 0;
            x = (ex+10)/20;
            y = (ey+10)/20;
            d = l[x][y];
            if ((d > 15) && (d<256)) /* bullet hit solid or breakable wall */
               {
                  e_bullet_active[b] = 0;  /* bullet dies */
                  if ((d > 23) && (d < 32)) /* remove breakable wall */
                     {
                        l[x][y] = 0;
                        blit(memory_bitmap[0], level_2000, 0, 0, (x*20), (y*20), 20, 20);
                        putpixel(map100_bkg, x, y, map_empty_color);
                     }
               }
            if (e_bullet_shape[b] > 1000)
               {
                   d =  e_bullet_shape[b]-1000;
                   d = zz[0][d];
                   draw_sprite(scrn_buffer, memory_bitmap[d], ex-WX, ey-WY);

               }
            else draw_sprite(scrn_buffer, memory_bitmap[e_bullet_shape[b]], ex-WX, ey-WY);
            if (map100_on) putpixel(map100_bmp, (ex-5)/20, y, map_bullet_color);
            /* check for collision with player */
            if (ex > (PXint - enemy_bullet_colision_window ))
               if (ex < (PXint + enemy_bullet_colision_window ))
                  if (ey > (PYint - enemy_bullet_colision_window ))
                     if (ey < (PYint + enemy_bullet_colision_window ))
                              {
                                 /* player got hit ! */

                                 switch (e_bullet_shape[b])
                                    {
                                       /* arrow */
                                       case 488:  LIFE -= 5  * dif; break;
                                       case 489:  LIFE -= 5  * dif; break;
                                       /* cannon ball */
                                       case 1055:  LIFE -= 7 * dif; break;
                                       /* yellow things */
                                       case 1020:  LIFE -= 9 * dif; break;
                                       /* green ball */
                                       case 1054:  LIFE -= 10 * dif; break;
                                   
                                    }
                                 if (sound_on) play_sample( snd[12], 127, 127, 1000, 0);
                                 sprintf(b_msg, "You got shot!");
                                 bottom_msg = 120;
                                 e_bullet_active[b] = 0;
                              }
         } /* end of if active */
}
proc_lit_rocket()
{
   for (c=0; c<500; c++)
      if (item[c][0] == 98) /* lit rocket! */
         {
            lit_item = 1;
            if (itemf[c][3] > -4) itemf[c][3] -=.06; /* accel */
            itemf[c][1] += itemf[c][3];
            x = itemf[c][0];
            y = itemf[c][1];
            if (c == (player_carry-1)) /* player is riding this rocket! */
               {
                  fall_count=0;
                  PY = itemf[c][1] + itemf[c][3];
                  if (PX >= itemf[c][0]) PX = itemf[c][0] + 14;
                  if (PX < itemf[c][0])  PX = itemf[c][0] - 14;
                  if (map100_on) putpixel(map100_bmp, x/20, y/20, 7);
                     {
                       int shape = 255;
                       a = item[c][1]; /* get shape */
                       if (a < 512) shape = a; /* bitmap */
                       if (a > 999) shape = zz[0][a-1000]; /* ans */
                       if (item[c][2] == 1) /* draw mode normal */
                           draw_sprite(scrn_buffer, memory_bitmap[shape], x-WX, y-WY);
                     }
               }
            if (is_up_solid(x, y, 0, 0))  /* rocket done */
               {
                  for (d=0; d<20; d++)  /* make boom! */
                     if (!bomb[d][0])  /* find empty */
                        {
                           itemf[c][3] = -.1; /* slow down lift */
                           bomb[d][0] = 32 + c; /* link to item */
                           bomb[d][1] = 5; /* total fuse wait */
                           bomb[d][2] = 1; /* seq fuse wait */
                           bomb[d][3] = item[c][7]; /* damage */
                           bomb[d][4] = 1; /* for blow up */
                           item[c][0] = 99; /* change to lit bomb */
                           d = 20; /* end bomb loop */
                        }

                     if (d == 19) item[c][0] = 0; /* erase, if no space in the bomb array */
               }
         }
}
proc_player_carry()
{
   if (player_carry)  /* move with player */
      {
         int pc = player_carry-1;
         if (item[pc][0] != 98) /* not lit rocket */
            {
               itemf[pc][1] = PY - 2;
               if (!left_right) itemf[pc][0] = PX - 15;
               if (left_right) itemf[pc][0] = PX + 15;
               x = (int) itemf[pc][0];
               y = (int) itemf[pc][1];
               if (map100_on) putpixel(map100_bmp, x/20, y/20, 7);
               if (item[pc][0] != 99) /* not lit bomb */
                     {
                       int shape;
                       a = item[pc][1]; /* get shape */
                       if (a < 512) shape = a; /* bitmap */
                       if (a > 999) shape = zz[0][a-1000]; /* ans */
                       if (item[pc][2] == 1) /* draw mode normal */
                           draw_sprite(scrn_buffer, memory_bitmap[shape], x-WX, y-WY);
                     }
               }
         if (!fire) /* drop */
            {
               player_carry = 0;
               if (item[pc][0] != 98) /* not lit rocket */
                  {
                     x = itemf[pc][0];
                     y = itemf[pc][1];
                     itemf[pc][2] = 0;  /* xinc = 0 */
                     if (fall_count) itemf[pc][3] = (sin(1.57-fall_count) * pmovey);
                     if (jump_count) itemf[pc][3] = (sin(jump_count) * pmovey);
  
                     if ((key[up_key]) || (joy_up))
                        itemf[pc][3] = -6; /* throw up */
  
                     if (p_xmove > 0)
                        if (!is_right_solid(x,y))
                           itemf[pc][2] = p_xmove;
  
                     if (p_xmove < 0)
                        if (!is_left_solid(x,y))
                           itemf[pc][2] = p_xmove;
                  }
               else /* lit rocket */
                  {

                  }

            } /* end of if (!fire) */
      } /* end of if player carry */
}
proc_lit_bomb()
{
   for (d=0; d<20; d++)   /* lit bomb handler! */
      if (bomb[d][0])   /* bomb lit! */
         {
            lit_item = 1;
            if (--bomb[d][1] > 0)  /* dec the fuse count */
               {
                  e = bomb[d][1] / bomb[d][2]; /* shape # */
                  c = zz[16-e][25];
                  x = itemf[bomb[d][0]-32][0];
                  y = itemf[bomb[d][0]-32][1];
   
                  if (bomb[d][1] < (bomb[d][2] * 5)) /* start blow-up */
                     {
                        a = ((bomb[d][2] * 6) - bomb[d][1]); /* 50 - ticks */
                        a = 2 * a * bomb[d][3]; /* 2 times damage */
                        a = a / (bomb[d][2] * 5);  /* / 50 */
   
                        if (map100_on)
                           {
                              rect(map100_bmp, (x/20)-(a/40), (y/20)-(a/40),(x/20)+(a/40), (y/20)+(a/40),10);
                              stretch_sprite(map100_bmp, memory_bitmap[c], (x/20) - (a/40), (y/20) - (a/40), 1 + (a/20), 1 + (a/20) );
                           }
                        stretch_sprite(scrn_buffer, memory_bitmap[c], (x-WX) - (a/2), (y-WY) - (a/2), 20 + a, 20 +a );
                     }
                  else draw_sprite(scrn_buffer, memory_bitmap[c], x-WX, y-WY);
               }
            if (bomb[d][1] < (bomb[d][2] * 6)) /* fuse done !*/
               if (bomb[d][4])  /* first time only */
                  {
                    if (sound_on) play_sample( snd[11], 200, 127, 1000, 0);
                     
                     bomb[d][1] = 23;  /* speed up ans */
                     bomb[d][2] = 4;
                     bomb[d][4] = 0;
                  }
            if (bomb[d][1] < (bomb[d][2] * 3)) /* do the damage! */
               {
                  c = bomb[d][3];  /* damage window */
                  x = itemf[ bomb[d][0]-32 ][0];
                  y = itemf[ bomb[d][0]-32 ][1];
                  bottom_msg = 120;
                  sprintf(b_msg, "KA-BOOM!");
   
                  for (e=0;e<100;e++) /* enemies in damage window? */
                     if (Ei[e][0])
                        if (Ef[e][0] > ((x-c)) )
                           if (Ef[e][0] < ((x+c)) )
                              if (Ef[e][1] > ((y-c)) )
                                 if (Ef[e][1] < ((y+c)) )
                                    {
                                       Ei[e][0] = 0; /* dead! */
                                       bottom_msg = 100;
                                       sprintf(b_msg, "Enemy killed by bomb!");
                                    }
   
                  if (PX > (x-c)) /* is player in window?*/
                     if (PX < (x+c))
                        if (PY > (y-c))
                           if (PY < (y+c))
                              {
                                 LIFE -= 3;
                              }
                  c /= 20;  /* convert to (0-100)  */
                  x /= 20;
                  y /= 20;
   
                  for (e = (x-c); e < (x+c)+1; e++)    /* erase on the maps */
                     for (f = (y-c); f < (y+c)+1; f++)
                       if ((e>0) && (e<99) && (f>0) && (f<99)) /* if on screen */
                           if (l[e][f] != 23) /* if not bullet_proof */
                                 {
                                    l[e][f] = 0;
                                    putpixel(map100_bkg, e, f, map_empty_color);
                                    blit(memory_bitmap[0], level_2000, 0, 0, e*20, f*20, 20, 20);
                                 }
                  draw_lift_lines();
               } /* end of damage */
            if (bomb[d][1] < 1)  /* bomb done */
               {
                  item[ bomb[d][0]-32 ] [0] = 0;
                  bomb[d][0] = 0;  /* set to inactive */
               }
         } /* end of if lit bomb */
}
draw_items()
{
   for (c=0; c<500; c++) /* rem update items on scrn_buffer */
      if (item[c][0])   /* if not type 0  */
         {
            int shape = 255; /* default */
            x = (int) itemf[c][0];
            y = (int) itemf[c][1];
            if (map100_on) putpixel(map100_bmp, x/20, y/20, 7);
            if ((item[c][0] != 99) && ((player_carry-1) != c) )
               if ((x > WX-20) && (x < (WX + SCREEN_W)) && (y > WY-20) && (y < (WY + SCREEN_H)))
                  {
                    /* get shape */
                    a = item[c][1];
                    if (a < 512) shape = a; /* bitmap */
                    if (a > 999) shape = zz[0][a-1000]; /* ans */
                    /* do draw mode */
                    if (item[c][2] == 1) /* draw mode normal */
                        draw_sprite(scrn_buffer, memory_bitmap[shape], x-WX, y-WY);
                  }
          }
}
proc_item_move()
{
   for (c=0; c<500; c++)  /* item move */
      if ((item[c][0]) && (item[c][3])) /* active and not stationary */
         if (item[c][0] != 98) /* not lit rocket */
            if (c != (player_carry-1)) /* not carrying */
               {
                  itemf[c][0] += itemf[c][2];  /* xinc */
                  itemf[c][1] += itemf[c][3];  /* yinc */
                  x = (int) itemf[c][0];
                  y = (int) itemf[c][1];
                  if (itemf[c][2] > 0) itemf[c][2] -= .01; /* slow down x move */
                  if (itemf[c][2] < 0) itemf[c][2] += .01; /* slow down x move */
   
                  if (itemf[c][2] > 0) /* right */
                     if (is_right_solid(x,y)) /* check for block right */
                        itemf[c][2] = 0;  /* stop */
   
                  if (itemf[c][2] < 0) /* left */
                     if (is_left_solid(x,y)) /* check for block left */
                        itemf[c][2] = 0;  /* stop */
   
                  if (itemf[c][3] < 0) /* rising */
                    {
                       if (!is_up_solid(x,y,1,1)) itemf[c][3] += .1; /* de-accel */
                       else itemf[c][3] = 0; /* stop y move if hit ceiling */
                    }
                 if (itemf[c][3] > 0) /* falling */
                    {
                       if (!is_down_solid(x,y, 1)) /* check for block below */
                          {
                             itemf[c][3] += .1;  /* accel */
                             if (itemf[c][3] > 3) itemf[c][3] = 3;  /* max accel */
                          }
                       else
                          {
                             if (itemf[c][2] > 0) itemf[c][2] -= .15; /* slow down x move if on ground */
                             if (itemf[c][2] < 0) itemf[c][2] += .15; /* slow down x move if on ground */
   
                             itemf[c][1] = ((y/20)*20); /* align with ground */
   
                             itemf[c][3] = 0; /* stop y move if on ground */
                          }
                     }
                if (itemf[c][3] == 0) /* yinc steady */
                    {
                       a = is_down_solid(x,y,1); /* check for block below */
                       if (a==0)
                          {
                             itemf[c][3] += .1;  /* accel */
                             if (itemf[c][3] > 4) itemf[c][3] = 4;  /* max accel */
                          }
                       if (a==1)
                          {
                             itemf[c][3] = 0; /* stop y move if on ground */
                             if (itemf[c][2] > 0) itemf[c][2] -= .03; /* slow down x move if on ground */
                             if (itemf[c][2] < 0) itemf[c][2] += .03; /* slow down x */
                          }
                       if (a > 31) /* item riding mov  */
                          {
                             itemf[c][0] += mov_obf[a-32][2] ; /* move with xinc */
                             itemf[c][1] = mov_obf[a-32][1] - 20; /* align with Y1 */
                             if (itemf[c][2] > 0) itemf[c][2] -= .03; /* slow down x move if on ground */
                             if (itemf[c][2] < 0) itemf[c][2] += .03; /* slow down x */
                          }
                     }
               }  /* end of if not carry */
}
proc_item_collison()
{
   for (x=0; x<500; x++) /* item collision with man */
      if (item[x][0])  /* is object active */
         if ((PX > itemf[x][0] - 16) && (PX < itemf[x][0] + 16))
            if ((PY > itemf[x][1] - 16) && (PY < itemf[x][1] + 16))
               {
                  if (item[x][3] == -1) /* try to pick up item */
                     if ((fire) && (!player_carry))  /* if not already carrying */
                        player_carry = x+1;
                  switch (item[x][0]) /* type */
                     {
                        case 1:  /* door */
                           if (sound_on) play_sample( snd[9], 200, 127, 1000, 0);
                           PX = item[x][6] * 20;
                           PY = item[x][7] * 20;
                           left_speed=0;
                           right_speed=0;
                           jump_count=0;
                           fall_count=0;
                           bottom_msg = 120;
                           sprintf(b_msg, "Teleport Door!");
                           if (sound_on) play_sample( snd[9], 200, 127, 1000, 0);
                     
                           if (WX < 0) WX = 0;
                           if (WX > 1680) WX = 1680;
                           if (WY>1800) WY = 1800;
                           if (WY < 0) WY = 0;
                           fade_out(10);
                           blit(level_2000, scrn_buffer, WX, WY, 0, 0, 320, 200);
                           fade_in(pallete,10);
                        break;
                        case 2:
                                
                           if (item[x][7])
                              {
                                 if (LIFE < 100)
                                    {
                                       item[x][0] = 0;
                                       LIFE += item[x][7];
                                       if (LIFE > 100) LIFE = 100;
                                       if (sound_on) play_sample( snd[6], 200, 127, 1000, 0);
                                       bottom_msg = 120;
                                       sprintf(b_msg, "Health Bonus! %d", item[x][7]);
                                    }
                                 else
                                    {
                                       bottom_msg = 20;
                                       sprintf(b_msg, "You already have perfect health!");
                                    }
                              }
                           if (item[x][8])
                              {
                                 if (num_bullets < max_bullets) /* only if not full */
                                    {
                                       item[x][0] = 0;
                                       num_bullets += item[x][8];
                                       if (num_bullets > max_bullets) num_bullets = max_bullets;
                                       if (sound_on) play_sample( snd[6], 200, 127, 1000, 0);
                                       bottom_msg = 120;
                                       sprintf(b_msg, "Bullet Bonus! %d", item[x][8]);
                                    }
                                 else
                                    {
                                       bottom_msg = 20;
                                       sprintf(b_msg, "You already have %d bullets!", num_bullets);
                                    }
                              }
                           if (item[x][9])
                              {
                                 item[x][0] = 0;
                                 level_time += item[x][9] * 50;
                                 if (sound_on) play_sample( snd[6], 200, 127, 1000, 0);
                                 bottom_msg = 120;
                                 sprintf(b_msg, "Timer Bonus! %d", item[x][9]);
                              }
                        break;
                        case 3: /* exit */
                            if ( (item[x][8]) && (num_enemy) )
                               {
                                    bottom_msg = 120;
                                    sprintf(b_msg, "%d enemies left!", num_enemy);
                               }
                            else
                               {
                                  level_done = 1;
                                  if (sound_on) play_sample( snd[9], 200, 127, 1000, 0);
                               }
                         break;
                         case 4:
                            item[x][0] = 0;
                            bottom_msg = 120;
                            sprintf(b_msg, "Locked block(s) removed!");
                            if (sound_on) play_sample( snd[9], 200, 127, 1000, 0);
                            for (c = item[x][6]; c <= item[x][8]; c++)
                               for (y = item[x][7]; y <= item[x][9]; y++)
                                  {
                                     l[c][y] = 0;
                                     blit(memory_bitmap[0], level_2000, 0, 0, c*20, y*20, 20, 20);
                                     putpixel(map100_bkg, c, y, map_empty_color);

                                  }
                            draw_lift_lines();

                         break;
                         case 6: /* free man */
                            item[x][0] = 0;
                            LIVES++;
                            bottom_msg = 120;
                            sprintf(b_msg, "Extra Life!");
                            if (sound_on) play_sample( snd[5], 200, 127, 1000, 0);
                                
                            break;
                      

                         case 7:
                           bottom_msg = 120;
                           sprintf(b_msg, "You hit a mine!");
                           LIFE -= (float) item[x][8]/10;
                         break;
                         case 8: /* un-lit bomb */
                           item[x][0] = 99; /* lit bomb */
                           item[x][3] = -1; /* carry */
                           bottom_msg = 120;
                           sprintf(b_msg, "#%d Bomb with %d second fuse",item[x][7]/20, item[x][9]/10 );
                           for (d=0; d<20; d++)
                              if (!bomb[d][0])  /* find empty */
                                 {
                                    bomb[d][0] = 32 + x; /* link to item */
                                    bomb[d][1] = item[x][9] * zz[4][25]; /* total fuse wait */
                                    bomb[d][2] = item[x][9]; /* seq fuse wait */
                                    bomb[d][3] = item[x][7]; /* damage */
                                    bomb[d][4] = 1; /* for blow up */
                                    d = 20; /* end bomb loop */
                                 }
                               else if (d == 19) item[x][0] = 0; /* erase if no space in the bomb array */
                         break;
                         case 10: /* POP UP MESSAGE */
                           pop_msg = x+1;
                         break;
                         case 11: /* rocket */
                           bottom_msg = 120;
                           sprintf(b_msg, "Rocket lit!");

                           item[x][1] = 1026; /* new ans */
                           item[x][0] = 98; /* new type - lit rocket */
                           item[x][3] = -1; /* carryable */

                           itemf[x][3] = 0; /* stop if falling */

                         break;
             
                      } /* end of switch case */
               } /* end of if on screen */

}
void pm_main() /* game loop! */
{
int fade_in_count = 2; /* for fade in */
int loop_time = 0;
text_mode(-1);  /* masked */
do /* start of game loop */
   {
      if (start_mode)
         {
            if (start_mode == 1)  /* load level */
               {
                  if (!load_level(play_level,0))
                     {
                        game_exit = 1;
                        resume_allowed = 0;
                        goto badload;
                     }
                  else
                     {
                        bottom_msg=0;
                        initialize_zz();
                        maps_and_background_fill();
                     }
               }
            if (start_mode == 2) /* resume after death */
               {
                  LIFE = 100;
                  num_bullets = 100;
                  right_speed = left_speed = 0;
                  jump_count = fall_count = 0;
               }
            /* draw_game_screen(play_level); */
            for (c=0; c<500; c++)  /* get start and time */
               if (item[c][0] == 5)
                  {
                     PX = itemf[c][0];
                     PY = itemf[c][1];
                     level_time = item[c][8] * 50;
                     break;
                  }
            player_carry = 0;
            player_ride = 0;
            level_done = 0;
      
            fade_out(fade_count);
            fade_in_count = 4;
            start_mode = 0;
         }
      /*  true game loop starts here !!!!  above is only one decision */

      /* frame speed delay */
      while ((msec_timer-loop_time) < frame_speed);
      loop_time = msec_timer;

      /* level_time dec and check */
      level_time -= 1;

      if (--bottom_msg > 0) textout_centre(scrn_buffer, font, b_msg, SCREEN_W/2, SCREEN_H-16, bottom_display_color);

      if (top_display_on)
         {
            int ho = 69;

            sprintf(msg,"Level:%-3d",play_level) ;
            textout(scrn_buffer, font, msg, top_display_x + 2, top_display_y + 2, top_display_color);
            sprintf(msg,"Lives:%-1d",LIVES) ;
            textout(scrn_buffer, font, msg, top_display_x + 2, top_display_y + 11, top_display_color);
            sprintf(msg,"Health") ;
            textout(scrn_buffer, font, msg, top_display_x + ho+2, top_display_y + 2, top_display_color);
            rectfill (scrn_buffer, top_display_x+ho, top_display_y + 10, top_display_x + ho+50, top_display_y +17, 10); /*  red   */
            rectfill (scrn_buffer, top_display_x+ho, top_display_y + 10, top_display_x + ho+(LIFE/2), top_display_y +17, 11); /*  green */

            sprintf(msg,"Time:%-3d",level_time/50);
            textout(scrn_buffer, font, msg, top_display_x + 124, top_display_y + 2, top_display_color);
            sprintf(msg,"Shot:%-3d",num_bullets);
            textout(scrn_buffer, font, msg, top_display_x + 124, top_display_y + 11, top_display_color);
         }

      if (map100_on)
         {

            int map_double;
            if (SCREEN_W == 320)   map_double = 1;
            if (SCREEN_W == 640)   map_double = 2;
            if (SCREEN_W == 800)   map_double = 2;
            if (SCREEN_W == 1024)  map_double = 3;


            if ( (PX-WX) < map_double*100 )          map100_x = SCREEN_W - map_double*100;
            if ( (PX-WX) > SCREEN_W-100*map_double ) map100_x = 0;

            if ( (PY-WY) < map_double*100 )          map100_y = SCREEN_H - map_double*100;
            if ( (PY-WY) > SCREEN_H-100*map_double ) map100_y = 0;

            stretch_blit(map100_bmp, scrn_buffer, 0, 0, 100, 100, map100_x, map100_y, map_double*100, map_double*100);

            blit(map100_bkg, map100_bmp, 0,0,0,0,100,100);


         }
      if (pop_msg) draw_pop_msg();
      pop_msg = 0;

      blit(scrn_buffer, screen, 0,0,0,0, SCREEN_W,SCREEN_H); /* screen buffer to screen */
      if (fade_in_count) if (--fade_in_count == 0) fade_in(pallete,fade_count);


      move_lifts();
      proc_controllers();
      player_move();
      get_new_background();
      update_animation();

      draw_items();
      draw_player();
      draw_lifts();

      proc_ebullets();
      proc_pbullets();

      enemy_move();
      enemy_draw_and_collision();

      proc_lit_rocket();

      proc_player_carry();

      proc_item_collison();

      proc_item_move();

      proc_lit_bomb();


      if (sound_on)
         {
            if ((!fuse_loop_playing) && (lit_item))
               {
                  fuse_loop_playing = 1;
                  play_sample(snd[7], 200, 127, 1000, 1);
               }
            if ((fuse_loop_playing) && (!lit_item))
               {
                  fuse_loop_playing = 0;
                  stop_sample(snd[7]);
               }
            lit_item = 0;
         }

      if (LIFE>100) LIFE = 100;

      if (level_time < 40) LIFE = -1;

      if (LIFE < 0)
         {
            start_mode = 2;

            if (sound_on)
               {
                  stop_sample( snd[7] );
                  play_sample( snd[2], 255, 127, 1000, 0);
                  play_sample( snd[2], 255, 127, 1000, 0);
               }
            if (level_time < 40) /* out of time */
               {
                  time_up();
               }
            else you_died();


            if (--LIVES < 0)
               {
                  game_over();
                  resume_allowed = 0;
                  top_menu_sel = 2;
                  game_exit = 1;
               }
            else
               {
                  rest(1000);
                  press_any();
               }
         }
#ifdef FV
if (level_done)
         {
            if (sound_on)
               {
                  stop_sample( snd[7] );
               }

            lev_done();
            play_level++;
            start_mode = 1;
         }
#endif

#ifdef SW
      if (level_done)
         {
            if (sound_on)
               {
                  stop_sample( snd[7] );
               }

            lev_done();
            bottom_msg=0;
            help(8);
            game_exit = 1;
            resume_allowed = 0;
            top_menu_sel = 2;
         }
#endif

badload:

    } while (!game_exit); /*  */
text_mode(0);  /* normal */
clear_keybuf();
}

